SystemOrganization addCategory: #'Seaside28Jetsam-Info'!
SystemOrganization addCategory: #'Seaside28Jetsam-Tests'!
SystemOrganization addCategory: #'Seaside28Jetsam-Document'!
SystemOrganization addCategory: #'Seaside28Jetsam-Tests-Functional'!
SystemOrganization addCategory: #'Seaside28Jetsam-Libraries'!
SystemOrganization addCategory: #'Seaside28Jetsam-FilesystemLink'!
SystemOrganization addCategory: #'Seaside28Jetsam-ControlPanel'!
SystemOrganization addCategory: #'Seaside28Jetsam-Useful-CSS'!
SystemOrganization addCategory: #'Seaside28Jetsam-CurrentUser'!
SystemOrganization addCategory: #'Seaside28Jetsam-Helpers-Rendered'!
SystemOrganization addCategory: #'Seaside28Jetsam-Helpers-Session'!
SystemOrganization addCategory: #'Seaside28Jetsam-Helpers-Configuration'!
SystemOrganization addCategory: #'Seaside28Jetsam-Useful-Data'!
SystemOrganization addCategory: #'Seaside28Jetsam-Debugging'!
SystemOrganization addCategory: #'Seaside28Jetsam-CreditCard'!
SystemOrganization addCategory: #'Seaside28Jetsam-Useful-JS'!
SystemOrganization addCategory: #'Seaside28Jetsam-Dialogs'!
SystemOrganization addCategory: #'Seaside28Jetsam-AbsoluteFudgeIE6'!
SystemOrganization addCategory: #'Seaside28Jetsam-NiftyCorners'!
SystemOrganization addCategory: #'Seaside28Jetsam-Supersleight'!
SystemOrganization addCategory: #'Seaside28Jetsam-Blueprint'!

!WADispatcher methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/28/2008 12:10'!
postProcessRequest: aRequest returned: response
	
	| handler key |
	 
	handler := self handlerForRequest: aRequest.
	key := WAExternalID fromString: (response fieldAt: 'Session' ifAbsent: [ ^ nil ]).
	
	handler isApplication ifFalse: [ ^ self ].
	handler :=  handler handlersByKey at: key ifAbsent: [ ^ nil ].
	 
	handler ifNil: [ ^ self ].
	handler isActive ifFalse: [ ^ self ].
	
	handler postProcessRequest: aRequest returned: response
		
 ! !

!WAErrorHandler class methodsFor: '*seaside28jetsam-override' stamp: 'kph 12/8/2007 06:50'!
internalError: anError

	^ self new internalError: anError! !

!WAErrorHandler methodsFor: '*seaside28jetsam-debugging-override' stamp: 'kph 12/8/2007 06:52'!
internalError: anError
	 
	Preferences debugInternalErrors  ifTrue: [  self halt ].

	^ WAResponse internalError: anError! !

WADecoration subclass: #WAHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAHelper commentStamp: 'kph 10/27/2007 02:59' prior: 0!
Helpers are decorations that automatically have the opportunity to be added to #createRoot:

Additional helpers can be added via subclassing without needing to override methods (#createRoot) that are already overriden.!

WAHelper subclass: #ShoreHelperHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!ShoreHelperHelper commentStamp: 'kph 11/4/2007 02:25' prior: 0!
This helper provides the support needed for Shore Components. It renders a number of elements which shore uses on every page.!

!ShoreHelperHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 02:50'!
isEnabledFor: application

	^ (application preferenceAt: #enableShoreHelper) ifNil: [ false ]! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 02:04'!
processChildCallbacks: aStream

	self variableShoreCurrentRoot use: self component during: [ super processChildCallbacks: aStream ]
! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 01:37'!
renderContentOn: html

	self renderOwnerOn: html.
	
	html div id: #shoreModalDialogOverlay; class: #hidden.

	html div id: #shoreProgressOverlay; class: #hidden.
	html div id: #shoreProgressSpinner; class: #hidden; with: [
		html image url: ('spinner.gif' asShoreUrl) ].

	html div id: #shoreModalDialogBox; class: #hidden;
		with: [ 
			html div id: #shoreModalDialogBoxHeader; with: [].
			html div id: #shoreModalDialog].

	html div id: #shoreContextMenu; class: #hidden; with: [
		html div id: #shoreContextMenuContent].

	html script: 'shoreResizeHandler(null);'.

! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:41'!
renderOwner: owner withShoreContext: aRenderingContext

 	
	| html callbacks |
	callbacks := aRenderingContext callbacksFor: self.
	html := self rendererClass context: aRenderingContext callbacks: callbacks.
	(owner showHalo and: [ aRenderingContext isDebugMode ])
		ifTrue: [ (WAHalo for: owner) renderContentOn: html ]
		ifFalse: [ owner renderContentOn: html  ].
	html flush	
! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:50'!
renderOwnerOn: html
	self owner ifNotNilDo: [:owner | 
		
		self variableShoreCurrentRoot use: self during: [
			
			owner renderWithContext: html context
			
		]
	].
	
! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 01:59'!
rendererClass

	^ Smalltalk at: #ShoreCanvas! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 6/10/2008 21:26'!
updateRoot: aHtmlRoot

 		{ ShoreStandardScripts.  
	ShoreStandardScheme.
	ShoreStandardStyles. } do: [ :ea  | ea default updateRoot: aHtmlRoot ].
	! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 02:02'!
variableShoreCurrentRoot

	^ Smalltalk at: #ShoreCurrentRoot! !

!ShoreHelperHelper methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 02:02'!
variableShoreCurrentTarget

	^ Smalltalk at: #ShoreCurrentTarget! !

WAHelper subclass: #WAEventHelper
	instanceVariableNames: 'parents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAEventHelper commentStamp: 'kph 11/4/2007 02:28' prior: 0!
EventHelper records the parents of each component rendered which WAComponent should do anyway.
 
This allows event handlers to propagate up the heirarchy properly.!

!WAEventHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/5/2007 23:40'!
isEnabledFor: app

^ false! !

!WAEventHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/4/2007 02:28'!
renderContentOn: html

	parents := IdentityDictionary new.
	self renderOwnerOn: html.
	! !

!WAHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:10'!
helpersFor: application addTo: rootComponent 

	"each helper has the opportunity to nominate an alternative root component or nil"
	| newRoot |

	self allSubclasses do: 
			[:each | 
			(each isEnabledFor: application) 
				ifTrue: [ newRoot := each new addDecorationTo: rootComponent]].
	^ newRoot ifNil: [ rootComponent ].! !

!WAHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 02:49'!
isEnabledFor: application

	self subclassResponsibility! !

!WAHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:12'!
addDecorationTo: rootComponent

	"double-dispatch missing from WADecoration"
	rootComponent addDecoration: self.
	
	"IMPORTANT - return the root component or a substitute root"
	
	^ rootComponent! !

WAHelper subclass: #WAKeepSessionAliveHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAKeepSessionAliveHelper commentStamp: 'kph 11/4/2007 02:24' prior: 0!
This helper appends a script to the root component which prevents the users session from expiring if their browser window is still open.!

!WAKeepSessionAliveHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:16'!
isEnabledFor: application
	 
	^ (application preferenceAt: #keepSessionAlive) ifNil: [ false ]
	
! !

!WAKeepSessionAliveHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:17'!
renderContentOn: html

	self renderOwnerOn: html.
	 
     html script: (html request
       				every: (self preferenceAt: #sessionExpirySeconds) - 60).
! !

WAHelper subclass: #WAToolbarHelper
	instanceVariableNames: 'frame'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Rendered'!

!WAToolbarHelper commentStamp: 'kph 11/10/2007 00:23' prior: 0!
The toolbar helper provides the toolbar when in deployment mode if the user session returns true from #showToolBarHelper

The toolbar's terminate action also works although it is disabled normally.

!

!WAToolbarHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:58'!
isEnabledFor: application
	 
	^ (application preferenceAt: #enableToolbarHelper) ifNil: [ false ]
	
! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:23'!
addDecorationTo: rootComponent

	super addDecorationTo: rootComponent.
	 
	"we could substitute the toolbar frame for the root here"
	^ rootComponent! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:46'!
getToolFrame

	^ frame := self isToolbarEnabled ifFalse: [ nil ] ifTrue: [ frame ifNil: [ self initializeToolFrame ] ]! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:31'!
initializeToolFrame

	^ WAToolFrame on: self component! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/10/2007 00:21'!
isToolbarEnabled
	
	| session | 
	
	(session := self session) application deploymentMode ifFalse: [ ^ false ].
	
	^ session showToolbarHelper ! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:55'!
processCallbackStream: aCallbackStream

	frame ifNil: [ ^ super processCallbackStream: aCallbackStream ].
	
	frame processTimeBegin.
	
	frame withDeprecatedHandlerDo: [ super processCallbackStream: aCallbackStream ]! !

!WAToolbarHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:45'!
renderContentOn: html

	self getToolFrame ifNil: [ ^ self renderOwnerOn: html ].
	
	frame on: html frameThis:  [ self renderOwnerOn: html ]. 
	 
	frame renderToolbarOn: html.
	! !

TestCase subclass: #JetsamTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Tests'!

!JetsamTestCase commentStamp: 'kph 7/19/2007 12:43' prior: 0!
JetsamTestCase tests for the presence of the fixes. This enables a quick if a little backwards method to assess whether a base version of seaside has any Jetsam fixes/extensions already present!!

Load seaside, just load JetsamTestCase (rather than the whole package), and if any tests "pass" then these could be candidates for removal from Jetsam.

!

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test01HasPreferenceGroup

	self assert: ((WADispatcher default entryPointAt:'config') configuration hasGroupNamed: #authentication) ! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test02ClearCachedDocument

	self assert: (WACachedDocument new respondsTo: #clear)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test03IdNotNil

	self assert: (WATagBrush new respondsTo: #idNotNil:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:37'!
test04ImageFilename

	self assert: (WAImageTag new respondsTo: #fileName:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:38'!
test05HeadingLevel

	self assert: (WAHtmlCanvas new respondsTo: #heading:level:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:43'!
test06downloadmimeTypefilename

	self assert: (WASession new respondsTo: #download:mimeType:filename:)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 7/19/2007 13:54'!
test08totalSize

	self assert: (WABatchedList new respondsTo: #totalSize)! !

!JetsamTestCase methodsFor: 'tests' stamp: 'kph 12/17/2007 20:59'!
test17totalSize

	self assert: (('' withoutTrailing: $/) = '').
	self assert: (('hello/world/' withoutTrailing: $/) = 'hello/world').
	self assert: (('hello/world' withoutTrailing: $/) = 'hello/world').! !

WAComponent subclass: #NiftyCornersCubeDemo
	instanceVariableNames: 'demo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-NiftyCorners'!

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:21'!
demo: selector

^ self basicNew 
		demo: selector; 
		initialize;
		yourself! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:28'!
example01

^ self demo: #example01
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:26'!
example02

^ self demo: #example02
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example03

^ self demo: #example03
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example04

^ self demo: #example04
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example05

^ self demo: #example05
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example06

^ self demo: #example06
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example07

^ self demo: #example07
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example08

^ self demo: #example08
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:27'!
example09

^ self demo: #example09
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:21'!
example10

^ self demo: #example10
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:22'!
example11

^ self demo: #example11
		 ! !

!NiftyCornersCubeDemo class methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:22'!
example12

^ self demo: #example12
		 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 06:20'!
demo: title

 
	demo := title! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:07'!
example01OnLoad
	^ 'Nifty("div#box", "big")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:10'!
example01RenderOn: html
 
	html div
		id: 'box';
		with: [ 
			
			html heading level: 1; with: [ html html: 'Nifty Corners Cube&trade;' ].

			html paragraph: 'One call. Two parameters. Three sizes'.
			
		].! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:28'!
example01Style

	^ '
	
	.component {
		background:#FFF;
		padding: 30px 0 0;	
  		font: 100.01%/1.3 Verdana,Arial,sans-serif;
		text-align:center
	}
	
	div#box {
		width: 18em;
		padding: 20px;
		margin:0 auto;
    		background:#E6E6E6;
		color:#000
	}

	h1 {
		font: lighter 200% "Trebuchet MS",Arial sans-serif;
		color: #208BE1
	}

	h1,p {
		margin:0;
		padding:10px 20px
	}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:28'!
example02OnLoad
	^ 'Nifty("div#content,div#nav")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:29'!
example02RenderOn: html

	html div
		id: 'content';
		with: [ 
			
			html heading level: 1; with: 'Nifty Corners;' .

			html paragraph: self gumpf.

			html heading level: 2; with: 'Rounded corners without images' .

			html paragraph: self gumpf.
			html paragraph: self gumpf.
			
		].
	
	html div
		id: 'nav';
		with: [ 
			
			html heading level: 2; with: 'Simple. Just Javascript and CSS.' .

			html paragraph: self gumpf.

		].! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:29'!
example02Style

	^ '
	.component {
		padding: 20px;
		background: #FFF;
		color: #333;
		text-align: center;
    		font:85%/1.45 "Lucida Sans Unicode","Lucida Grande",Arial,sans-serif
	}

	h1,h2,p {
		margin: 0;
		padding: 0 10px
	}
	p { 
		padding: 0 10px 1em
	}

	h1,h2 {
		letter-spacing: -1px;
		font-weight:100;
		color: #111
	}

	h1 {
		font-size: 200%
	}

	h2{
		font-size: 140%;
		line-height:1.05
	}

	div.component {
		width:450px;
		margin: 0 auto;
		padding:10px 0;
		text-align:left
	}
	div#content { 
		float:left;
		width:300px;
		padding:10px 0;
		background: #BAFB80
	}
	div#nav {
		float:right;
		width:145px;
		padding:10px 0;
		background:#DBCAEE 
	}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:29'!
example03OnLoad
	^ 'Nifty("div#box","transparent")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:29'!
example03RenderOn: html
 

	html div
		id: 'box';
		with: [ 
			
			html heading level: 1; with: [ html html: 'Nifty Corners Cube&trade;' ].

			html paragraph: 'Easier than ever;'.
	
	html html: '<ol>
<li>Automatic detection of color and background color</li>
<li>Automatic smoothing and transparency</li>
<li>Preservation of padding, so more presentational unobtrousive</li>
<li>Ability to choose the corners to round and the size</li>
<li>just one or two parameters</li>
</ol>'
 
		].
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:31'!
example03Style

	^ '
	.component {
		padding: 50px 0 0;
		background:#FFF;
		color:#111;
		font: 100.01%/1.3 Verdana,Arial,sans-serif;
		text-align:center
	}

	div#box{
		width: 25em;
		padding: 30px  0;
		margin:0 auto;
		text-align:left;
		background: #9CC0FF url(gradient.png) repeat-x 0 -5px
	}
	
	h1 {
		font: lighter 200% "Trebuchet MS",Arial sans-serif;
		color: #303F6E
	}
	h1,p { margin:0 20px }
	ol {
		margin:10px 40px;
		padding:0
	}
	ol li {
		margin:0;
		padding:0
	}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:47'!
example04OnLoad
	^ 'Nifty("ul#nav a","medium transparent top")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:37'!
example04RenderOn: html
 

	html html: '
	<div id="menu">
    <ul id="nav">
        <li id="home" class="activelink"><a href="#">Home</a></li>
        <li id="who"><a href="#">About</a></li>
        <li id="prod"><a href="#">Product</a></li>
        <li id="serv"><a href="#">Services</a></li>
        <li id="cont"><a href="#">Contact us</a></li>
    </ul>
</div>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:51'!
example04Style

	^ '
html, body {
	margin:0;
	padding:0}

.chooser, h4 {
	margin : 10px;
	padding : 5px;
}
.component {
	background: #FFF;
	font: 70% Arial,sans-serif}

div#menu {
	float:left;
	width: 100%;
	padding-top:120px;
	background: #BBD9EE }

ul#nav,ul#nav li {
	list-style-type:none;
	margin:0;
	padding:0 
}
ul#nav {
	margin-left: 100px;
	width:650px}
ul#nav li {
	float:left;
	margin-right: 3px;
	text-align: center}
ul#nav a {
	float:left;
	width: 7em;
	padding: 5px 0;
	background: #E7F1F8;
	text-decoration:none;
	color: #666
}
ul#nav a:hover {
	background: #FFA826;
	color: #FFF
}
ul#nav li.activelink a,ul#nav li.activelink a:hover {
	background: #FFF;
	color: #003
}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:54'!
example05OnLoad
	^ 'Nifty("ul.postnav a","transparent")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:55'!
example05RenderOn: html
 

	html html: '
<ul class="postnav">
<li><a href="#">permalink</a></li>
<li><a href="#">comments</a></li>
<li><a href="#">trackback</a></li>
</ul>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:57'!
example05Style

	^ '
.component{padding: 20px;
	background:#FFF;
	font:76% Arial,sans-serif}
ul.postnav,ul.postnav li{margin:0;
	padding:0;
	list-style-type:none}
ul.postnav li{float:left;
	width: 9em;
	font-size:140%;
	margin-right: 5px}
ul.postnav a{display:block;
	width:9em;
	padding:5px 0;
	font: bold 100% Verdana,Arial,sans-serif;
	
    text-transform:uppercase;
	background: #C7FF5A;
	color: #666;
	
    text-decoration:none;
	text-align:center}
ul.postnav a:hover{background: #A8E52F;
	color:#FFF}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:58'!
example06OnLoad
	^ 'Nifty("div#about li","tl bottom big fixed-height")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 07:58'!
example06RenderOn: html
 

	html html: '
<ul id="about">
    <li id="ab1">Explore new possibilities</li>
    <li id="ab2">Discover colors easily</li>
    <li id="ab3">Design CSS without worries</li>
    <li id="ab4">Plug and run your rounded corners...</li>
    <li id="ab5">...without any graphics!!</li>
    <li id="ab6">Nifty Corners Cube&trade;</li>
</ul>

'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:18'!
example06Style

	^ '
.component {background: #FFF;
	color: #333;
	text-align:center;
	font: 16px "Trebuchet MS",Verdana,Arial,sans-serif}
ul#about,ul#about li{list-style-type:none;
	margin:0;
	padding:0}
ul#about{width: 474px;
	margin:70px auto 0;
	text-align:left}
ul#about li{float:left;
	width: 120px;
	 height:100px;
	
    padding: 30px 10px 20px 20px;
	margin:8px 8px 0 0}
li#ab1{background: #FC0}
li#ab2{background: #9F3}
li#ab3{background: #F60}
li#ab4{background: #39F}
li#ab5{background: #F36}
li#ab6{background: #FFF;
	color: #000}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:19'!
example07OnLoad
	^ 'Nifty("div#content,div#nav","same-height")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:20'!
example07RenderOn: html
 

	html html: '
<div id="content">
<h1>Nifty Corners</h1>
<p>Auiiui  uieiouo auuaa oiaue uaou iioiiou uiio a io ieeoai uaouoe uoiaau eeauauou u oiauuie eo ui.</p>
<h2>Rounded corners without images</h2>
<p>Aaeao aiieuouiu io ueuiieu uei oeio uooiau uue ooiea ooiaui eue ouue i uiaoo iouieiuia uueeo ieieuiiau
ueaooa iou iaeieuo uoao iauoi u i oeioooe auo a ooe u uuuo oaooaae uoa iuiuiaeu iioaeu uuiu eeu ea eouoiuo ua o.</p>
<p>Iiuiuaea ouea ieuuio o eoo iaoa euiaou uoia
uuei ua aoauia ieoae eioiaia eu uiueeiui ueuaiuo uaa eie oaeee uau ooieoi uoii oeuioei uouiiuu ioeiuoe eaeuoi.</p>
</div>
<div id="nav">
<h2>Simple. Just Javascript and CSS.</h2>
<p>Aoioeou eeeu ueeiuiii uoauiioi uae eoeoioe ouiui oieouoo uioo uaieeoe oe eouoiea a oou uiu.</p>
</div>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:23'!
example07Style

	^ '
.component{padding: 20px;
	background: #FFF;
	color: #3C0012;
	text-align: center;
	
    font:85%/1.45 "Lucida Sans Unicode","Lucida Grande",Arial,sans-serif}
h1,h2{margin: 0;
	padding: 0 10px;
	letter-spacing: -1px;
	font-weight:100;
	color: #FFF}
h1{font-size: 200%}
h2{font-size: 140%}
p{margin:0;
	padding: 0 10px 1em}
div.component{width:450px;
	margin: 0 auto;
	padding:10px 0;
	text-align:left}
div#content{float:left;
	width:300px;
	padding:10px 0;
	background: #FFBD00}
div#nav{float:right;
	width:145px;
	padding:10px 0;
	background:#42B4AC}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:23'!
example08OnLoad
	^ 'Nifty("ul#split li","same-height")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:24'!
example08RenderOn: html
 

	html html: '
<ul id="split">
<li id="one"><h3>Title one</h3>
<div>
<p>Eiu iae eiouuu io eiiu e eo eee ue uaioeo eiea euooi iueui a eieuoo iau iaio ieeoaiui.</p>
<p>Iie u uiuou uaueiei ioou ouu o e uue aeiii o euoueeei iueuou ei aoeaei ui eeoueuo e ioi.</p>
</div>
</li>
<li id="two"><h3>Title two</h3>
<div>
<p>Uiiui ieoai ooiu iuo oo iaoouuo ouiue ui oa aeiooi ieuuu ue auaou euui oieoeo iai aaoo.</p>
<p>Ueauiuiiu oauue iiouoi eiiiaeaa ioeu e eio iioui iu o ieooua aooiu ooiu o oau oo ouuau ueuoeii ieieoeee aee.</p>
<p>Uiee io u e ee ea iioe ioeuaoe ooai u.</p>
</div>
</li>
<li id="three"><h3>Title three</h3>
<div>
<p>iei ooo ui ui eeiuiuoi uiauoe ieuii ii aia eiii eueieie ouio oi.</p>
<p>Iu iuiui aeeoio aouea euaeu ouuu aoooe eueo uei ueeu ea uieuiuu uo ui e aeuu eaeia oui.</p>
<p>Oeouo ue uuei e ieuee o uooeuoo eaeeu oeieioa aoaea iuia ue uia oiau a uoeo.</p>
</div>
</li>
</ul>



</ul>
</ul>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 08:24'!
example08Style

	^ '
component {background: #FFF;
	color:#333;
	
    font: 76% Arial,sans-serif}

ul#split,ul#split li{margin:0;
	padding:0;
	list-style:none}
ul#split li{float:left;
	width:150px;
	margin:0 10px 10px 0}
ul#split h3{font: normal 120%/1.3 Verdana,sans-serif;
	
    text-transform:uppercase;
	margin:0px;
	padding: 5px 0 0;
	text-align:center;
	color: #000}
ul#split p{margin:0;
	padding:5px 8px 15px}
li#one{background: #C8C866}
li#two{background: #FFBD00}
li#three{background: #E3A1C4}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:35'!
example09OnLoad
	^ 'Nifty("ul#split h3","top");Nifty("ul#split div","bottom same-height")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:36'!
example09RenderOn: html
 

	html html: '
<ul id="split">
<li id="one"><h3>Title one</h3>
<div>
<p>Eiu iae eiouuu io eiiu e eo eee ue uaioeo eiea euooi iueui a eieuoo iau iaio ieeoaiui.</p>
<p>Iie u uiuou uaueiei ioou ouu o e uue aeiii o euoueeei iueuou ei aoeaei ui eeoueuo e ioi.</p>
</div>
</li>
<li id="two"><h3>Title two</h3>
<div>
<p>Uiiui ieoai ooiu iuo oo iaoouuo ouiue ui oa aeiooi ieuuu ue auaou euui oieoeo iai aaoo.</p>
<p>Ueauiuiiu oauue iiouoi eiiiaeaa ioeu e eio iioui iu o ieooua aooiu ooiu o oau oo ouuau ueuoeii ieieoeee aee.</p>
<p>Uiee io u e ee ea iioe ioeuaoe ooai u.</p>
</div>
</li>
<li id="three"><h3>Title three</h3>
<div>
<p>iei ooo ui ui eeiuiuoi uiauoe ieuii ii aia eiii eueieie ouio oi.</p>
<p>Iu iuiui aeeoio aouea euaeu ouuu aoooe eueo uei ueeu ea uieuiuu uo ui e aeuu eaeia oui.</p>
<p>Oeouo ue uuei e ieuee o uooeuoo eaeeu oeieioa aoaea iuia ue uia oiau a uoeo.</p>
</div>
</li>
</ul>



</ul>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:42'!
example09Style

	^ '

.component {background: #FFF;
	color:#333;
	
    font: 76% Arial,sans-serif}

ul#split,ul#split li{margin:0;
	padding:0;
	list-style:none}
ul#split li{float:left;
	width:150px;
	margin:0 10px 10px 0}
ul#split h3{font: normal 120%/1.3 Verdana,sans-serif;
	
    text-transform:uppercase;
	margin:0px;
	padding: 5px 0 3px;
	text-align:center;
	color: #000}
ul#split p{margin:0;
	padding:5px 8px 15px}
ul#split div{background:#C5E6F6}
li#one h3{background: #C8C866}
li#two h3{background: #FFBD00}
li#three h3{background: #E3A1C4}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:41'!
example10OnLoad
	^ 'Nifty("ul#split h3","top");Nifty("ul#split div","bottom same-height")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:44'!
example10RenderOn: html
  
	^ self example09RenderOn: html! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:41'!
example10Style

	^ '
.component {background: #FFF;
	color:#333;
	
    font: 76% Arial,sans-serif}

ul#split,ul#split li{
	margin:0;
	padding:0;
	list-style:none}
ul#split li{
	float:left;
	width:150px;
	margin:0 10px 10px 0}
ul#split h3{
	font: normal 120%/1.3 Verdana,sans-serif;
     text-transform:uppercase;
	margin:0px;
	padding: 5px 0 0;
	text-align:center;
	color: #000}
ul#split p{margin:0;
	padding:5px 8px 15px}
li#one h3{background: #C8C866}
ul#split div{background: #FFC}
li#one div{border:2px solid #C8C866}
li#two h3{background: #FFBD00}
li#two div{border:2px solid #FFBD00}
li#three h3{background: #E3A1C4}
li#three div{border:2px solid #E3A1C4}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:03'!
example11OnLoad
	^ 'Nifty("div#container");
	
Nifty("div#content,div#nav","same-height small");
	
Nifty("div#header,div#footer","small")'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:03'!
example11RenderOn: html
 

	html html: '
<div id="container">
<div id="header"><h1>Nifty Corners</h1></div>
<div id="content">
<p>Auiiui  uieiouo auuaa oiaue uaou iioiiou uiio a io ieeoai uaouoe uoiaau eeauauou u oiauuie eo ui.</p>
<h2>Rounded corners without images</h2>
<p>Aaeao aiieuouiu io ueuiieu uei oeio uooiau uue ooiea ooiaui eue ouue i uiaoo iouieiuia uueeo ieieuiiau
ueaooa iou iaeieuo uoao iauoi u i oeioooe auo a ooe u uuuo oaooaae uoa iuiuiaeu iioaeu uuiu eeu ea eouoiuo ua o.</p>
<p>Iiuiuaea ouea ieuuio o eoo iaoa euiaou uoia
uuei ua aoauia ieoae eioiaia eu uiueeiui ueuaiuo uaa eie oaeee uau ooieoi uoii oeuioei uouiiuu ioeiuoe eaeuoi.</p>
</div>
<div id="nav">
<h2>Simple. Just Javascript and CSS.</h2>
<p>Aoioeou eeeu ueeiuiii uoauiioi uae eoeoioe ouiui oieouoo uioo uaieeoe oe eouoiea a oou uiu.</p>
</div>
<div id="footer">footer here</div>
</div>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:03'!
example11Style

	^ '
.component {padding: 20px;
	background: #707883;
	color: #222;
	text-align: center;
	
    font: 85% "Trebuchet MS",Arial,sans-serif}
h1,h2,p{margin: 0;
	padding: 0 10px;
	font-weight:normal}
p{padding: 0 10px 15px}
h1{font-size: 250%;
	color: #FFF;
	letter-spacing: 1px}
h2{font-size: 200%;
	line-height:1;
	color:#002455 }
div#container{width:450px !!important;
	 width /**/:460px;
	
    margin: 0 auto;
	padding:5px;
	text-align:left;
	background:#FFF}
div#header{background: #BFDDED;
	padding: 10px;
	text-align:center}
div#content{float:left;
	width:300px;
	padding:10px 0;
	margin:5px 0;
	background: #778CCA}
div#nav{float:right;
	width:145px;
	padding:10px 0;
	margin:5px 0;
	background: #FFD154}
div#nav h2{font-size: 120%;
	color: #9E4A24}
div#footer{clear:both;
	width:450px;
	background: #C4E786;
	padding:5px 0;
	text-align:center}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:11'!
example12OnLoad
	^ 'Nifty("div#menu a","small transparent top");
Nifty("ul#intro li","same-height");
Nifty("div.date");
Nifty("div#content,div#side","same-height");
Nifty("div.comments div");
Nifty("div#footer");
Nifty("div#container","bottom");'
	
 ! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:04'!
example12RenderOn: html
 

	html html: '
<div id="header">
<h1>Nifty Corners Cube&trade;</h1>
<div id="menu">
<ul id="nav">
<li id="home" class="activelink"><a href="#">Home</a></li>
<li id="who"><a href="#">About</a></li>
<li id="prod"><a href="#">Product</a></li>
<li id="serv"><a href="#">Services</a></li>
<li id="cont"><a href="#">Contact us</a></li>
</ul>
</div>
</div>
<div id="container">
<div id="content">
<ul id="intro">
<li id="mission"><h3>Our Mission</h3><p>Oeoua aau ieiu a eoiu eo eoi ee ieeao uaio uoaua u iii.</p></li>
<li id="services"><h3>Our Services</h3><p>Euiuee iau oo ouo   uei e ae oiuueo.</p></li>
<li id="more"><h3>Our goals</h3><p>Ue eieoeo iooaiu iiiia aioea oo ii iuai uoeui u ai aa.</p></li>
</ul>
<p>Oi ieueea oeee uuio ouuo u oiu iao aaiou iaioue eououa iia uaeioo uei eo iiouu aoe ouu a iieuau i euaouu aua eiooa uiu aeoeo oe aoeo oi oo oiieu uio auie. Ouiu uia iioe uii ueoe uioe ii iu eauiiuu iueioo ieu ei aeueoo uuuiie  eiu aiie ioaieo oeuoe uu eeeo ouaouiu iiue euiia oeoii ieoiuo ouai ouo oio.</p>
<p>Oio iei aeuoa ie ouoao oiu io eaaoi aiai uiieaui iu iiee eaiai iuoe euaeo e uaooo ea ieuuu uiio e eiio ueeioi u uieia iuuuiai oo oouuie oooo uuioie oaiua ouou eoeo uooe.</p>

<h2>Nifty Corners Layout: ready for colors</h2>
<div class="date">MAR <span>22</span> 2006</div>
<p>Aeauiooa e eaii oiiea aeeeo uo ieu oia iai ae u eiu uoei euoi aiaee aoeu iueoee oiu ooi ioeoi ouooi uioeu uo ieao.</p>
<p>Eu aoia oueii aue uo e oee eueiae o ai ieoei eoooui ieie eau eaueeu uuio uuaoe euauua uouuiua oiuue aiiue uieioe eeio iio oiioa.</p>
<p>Ioue e aiaaoeu iuuue eiuuo aooo ue eiuu uo u iiuu euu ui uuieu eoou eueueu oou uiiua oi ai aa ioeui uoi iiuiua oou uo uoea iu eao o eeieoei ueoe euoei.</p>
<p>E ee eia e iiu ei o uuoi eiee e oo iooe euo iu euuui oe ieeeu eaiuuo eoo eau eooaa ae  ieoooue e uueu iiii iouu ea eio oeao uuui ueiuoe iaui ueio ueuooa eoe aoee eio.</p>
<p>Eu uuio ua ooao ue iaoiuiua oeoeoi eieeoi ei iu uuo u e oeeau aeui ei ueaiu o i ieiou uoi ooa.</p>

<div class="comments">
<div>
<p>Ueieu oeeoauoi aoi ieaaouo uaa oa ou ueuuaeu oeeeeio ioi oee euuuiu oiuooo uiuua aiuoio ueiu iuia i eiioueu eeooa au oueeo aioeeo ao ouiio eiou ooeoo e auoi uiuaoiia oau eoueea eoue uiueu ueeau eui eueeui au oueee iueuoei.</p>
</div>
<div class="odd">
<p>Iaoieueo uuuieai oauao uooo iiua aueeoi oai ooaio uoe ooouei ioe euuueiee oi eu e eoou ui o eei uaeaiou eeiuo oaueu ioo aeoeu uaiuue iie iueuie oaeuio iu oiuoue uauo eeeeueo eoua ao u ieeu eieaeie .</p>
</div>
<div>
<p>Aoi aoauoo e oei ii oeu uioauaa ouoeuii aui oeeuoo oeoii oaooii eie aioe ae ueeaoi ieo aio eiaoeeo oe iia eeo oueu oaaiuui iiiiu auoiie ee u aeuei uio ue oouo eeai aoo i ieuaieii.</p>
</div>
</div>
<p>Uaou  i uio uoeuui aiou oiuiaeo ue aeae uio ouiooieu ie iu uau ei io ieiu u uu iueu euia aeuea aueo iuua ieua ie ieia ui ee eeouu uea ia u eoi oo  ueeooeu eeou uoue oi ui eeoao ea.</p>
<p>Oeooe oeau io aeeou ueou uaio aoi aioua eiaa uuiiia eie aeoioaui iooou oi oouei e uooeu eu i u ueii eooee oi uee aiao eooii eiei iuouioe oaieeoe uoou eoouu ia e ii uuiu ii iaiiiei oaae uiuui eioai iai ueuu uuuue uee uuuiuo oiaou ea ioei aeeoua ae aeiii eioi oeouii ueu uu uauoeoo oe aaieo  eee.</p>
<p>Uaou  i uio uoeuui aiou oiuiaeo ue aeae uio ouiooieu ie iu uau ei io ieiu u uu iueu euia aeuea aueo iuua ieua ie ieia ui ee eeouu uea ia u eoi oo  ueeooeu eeou uoue oi ui eeoao ea.</p>
</div>

<div id="side">
<p>Oi ieueea oeee uuio ouuo u oiu iao aaiou iaioue eououa iia uaeioo uei eo iiouu aoe ouu a iieuau i euaouu aua eiooa uiu aeoeo oe aoeo oi oo oiieu uio auie.</p>
<p>Ouiu uia iioe uii ueoe uioe ii ouaouiu iiue euiia oeoii ieoiuo ouai ouo oio.</p>
<p>O uiu aeoeo oe aoeo oi oo oiieu uio auie.</p>
</div>

<div id="footer">
<p>Nifty Corner Cube&trade; both idea and execution by Alessandro Fulciniti</p>
'
! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:12'!
example12Style

	^ '
html,body{margin:0;padding:0}
body{font: 85%/1.3 Verdana,Arial,sans-serif;
    text-align: center;background: #757D88;padding-bottom:20px}
p{margin-top:0}
h1,h2,h3{font: normal normal 200% "Trebuchet MS",Arial,sans-serif}
h2{font-size:160%}
h3{font-size:120%}

div#header{width:100%;overflow:hidden;background: #595D66}
div#header h1,div#menu{width:770px;margin:0 auto;text-align:left}
div#header h1{padding: 30px 0 10px;color: #FFF}

ul#nav,ul#nav li{list-style-type:none;margin:0;padding:0}
ul#nav{float:right;font-size: 80%}
ul#nav li{float:left;margin-left: 3px;text-align: center}
ul#nav a{float:left;width: 95px;padding: 5px 0;background: #369A3D;text-decoration:none;color: #FFC}
ul#nav a:hover{background: #CDFFA1;color: #006A35}
ul#nav li.activelink a,ul#nav li.activelink a:hover{background: #FFF;color: #003}

div#container{width:770px;margin:0 auto 10px;padding:20px 0 10px;text-align:left;background:#FFF}
div#content{float:left;display:inline;width:560px;margin:0 0 10px 10px}

ul#intro,ul#intro li{list-style-type:none;margin:0;padding:0}
ul#intro{width:100%;overflow:hidden;margin-bottom:20px}
ul#intro li{float:left;width:180px;margin-right:10px;padding: 10px 0}
li#mission{background: #E65714}
li#services{background: #42B4AC}
ul#intro li#more{margin-right:0;background: #7D63A9}
ul#intro p,ul#intro h3{margin:0;padding: 0 10px}
ul#intro h3{text-transform:uppercase;padding-bottom:3px;color: #FFF}

div#content h2{margin: 10px 0;color: #007BC4}
div.date{float:left;width: 4em;padding: 5px 0;background: #F1DDC4;color:#B0001E;
    text-align:center;margin: 0 4px 4px 0;font-size: 80%;line-height:0.9}
div.date span{display:block;font-size: 150%;font-weight:bold}

div.comments div{background: #EEE;margin-bottom:10px}
div.comments p{padding: 10px;margin:0}
div.comments div.odd{background:#DAE6FE}

div#side{float:right;display:inline;width: 180px;background:#F3CF00; margin:0 10px 10px 0}
div#side p{margin:5px 0 10px;padding: 0 10px}
div#side div{margin: 0 0 10px;padding: 10px 0}

div#footer{clear:both;width:750px;margin:0 10px 0;padding: 10px 0;
    background: #586695;color: #FFF;text-align:center}
div#footer p{margin:0}
'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 20:54'!
gumpf

	^ 'Aaeao aiieuouiu io ueuiieu uei oeio uooiau uue ooiea ooiaui eue ouue i uiaoo iouieiuia uueeo ieieuiiau
ueaooa iou iaeieuo uoao iauoi u i oeioooe auo a ooe u uuuo oaooaae uoa iuiuiaeu iioaeu uuiu eeu ea eouoiuo ua o.'! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:47'!
renderContentOn: html
	
	html paragraph with: [ 
		
		html anchor url: 'http://www.html.it/articoli/niftycube/index.html'; with: 'Read about "Nifty Corners Cube".'
	].
	
	self perform: ( demo, 'RenderOn:') asSymbol with: html! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:45'!
renderHeaderOn: html! !

!NiftyCornersCubeDemo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 06:59'!
updateRoot: htmlRoot

	| library |
	
	library := NiftyCornersCube new.
	
	htmlRoot context session addLoadScript: (self perform: (demo , 'OnLoad') asSymbol).
	htmlRoot addScript: library niftycornersJs.
	htmlRoot addStyle: library niftycornersCss.
	htmlRoot addStyle: (self perform: (demo , 'Style') asSymbol).
	! !

WAComponent subclass: #WADispatcherControlPanel
	instanceVariableNames: 'appSession'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-ControlPanel'!

!WADispatcherControlPanel commentStamp: 'kph 7/27/2007 02:39' prior: 0!
This is a component which can be opened in response to an anchor in the WADispatcherEditor. 
Although it runs in the context of the editor session, the application to which it is relevent if given to it on opening.

For usage examples see 'Magma seaside' in http://www.squeaksource.com/MagmaTester 
or 'Pier-PersistencyManager' in http://mc.lukas-renggli.ch/pier
!

!WADispatcherControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 12/13/2007 02:21'!
cleanUp

	WeakRegistry default in: [ :registry |
		(registry select: [ :each | each isKindOf: self ])
			do: [ :one | registry remove: one finalize ifAbsent: [] ] 
	].! !

!WADispatcherControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:08'!
editorActionsFor: anEntryPoint inEditor: anEditor

	"for seaside version<=2.7"
 
	(anEntryPoint isApplication and: 
		[ anEntryPoint hasPreferenceGroup: self group]) ifFalse: [ ^ #() ].
 
	^(OrderedCollection new) 
		add: ((Dictionary new)
				at: #label put: self label;
				at: #action put: [ anEditor call: (self forApplication: anEntryPoint) ];
				yourself);
		yourself.
! !

!WADispatcherControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 10/29/2007 04:43'!
forApplication: anApp 

	| controlPanel |
	
	controlPanel := ((anApp preferenceAt: #sessionClass) application: anApp)
		in: [ :sess |	self basicNew appSession: sess; initialize ].

	controlPanel addDecoration: (WAWindowDecoration new title: controlPanel title; yourself).
	^controlPanel! !

!WADispatcherControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:08'!
group
	"for seaside version<=2.7"
 
	 ^ self label asLowercase asSymbol! !

!WADispatcherControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:06'!
label
	"for seaside version<=2.7"
 
	 ^ self subclassResponsibility ! !

!WADispatcherControlPanel class methodsFor: 'as yet unclassified' stamp: 'kph 7/27/2007 02:10'!
register

	"for seaside version <= 2.7"
	 (WADispatcherEditor respondsTo: #addPlugin:) 
		ifTrue:[ WADispatcherEditor addPlugin: self ]! !

!WADispatcherControlPanel methodsFor: 'finalization' stamp: 'kph 12/11/2007 10:39'!
actAsExecutor

	super actAsExecutor.
	appSession := appSession executor.! !

!WADispatcherControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 01:57'!
appSession

	^ appSession  ! !

!WADispatcherControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 01:57'!
appSession: session

appSession := session! !

!WADispatcherControlPanel methodsFor: 'accessing' stamp: 'kph 10/29/2007 05:06'!
application

	^ self appSession application! !

!WADispatcherControlPanel methodsFor: 'callback actions' stamp: 'kph 7/27/2007 01:58'!
done

self appSession expire.

self answer! !

!WADispatcherControlPanel methodsFor: 'finalization' stamp: 'kph 7/27/2007 01:59'!
executor

^ self class basicNew appSession: appSession; yourself! !

!WADispatcherControlPanel methodsFor: 'finalization' stamp: 'kph 7/27/2007 01:59'!
finalize

appSession ifNotNil: [

	appSession unregistered.

]
! !

!WADispatcherControlPanel methodsFor: 'testing' stamp: 'kph 7/27/2007 02:00'!
hasScriptaculous
	Smalltalk at: #SULibrary ifPresent: [ :class |
		^ self session application libraries
			includes: class ].
	^ false! !

!WADispatcherControlPanel methodsFor: 'initialization' stamp: 'kph 7/27/2007 02:01'!
initialize

super initialize.
self registerForFinalization.

! !

!WADispatcherControlPanel methodsFor: 'finalization' stamp: 'kph 7/27/2007 02:02'!
registerForFinalization

self finalizationRegistry add: self executor: self executor.! !

!WADispatcherControlPanel methodsFor: 'rendering' stamp: 'kph 7/27/2007 02:04'!
renderContentOn: html

	html heading level2; with: 'Application: ', self application name.
! !

!WADispatcherControlPanel methodsFor: 'callback actions' stamp: 'kph 7/27/2007 02:04'!
title
	^ self class name, ' - ', self application name, ' (', self application basePath, ')'! !

!WADispatcherControlPanel methodsFor: 'accessing' stamp: 'kph 7/27/2007 02:32'!
usingAppSession: aBlock
	WACurrentSession use: self appSession during: aBlock! !

!WATagBrush methodsFor: '*seaside28jetsam-convenience' stamp: 'gk 5/5/2006 11:46'!
idNotNil: aString
	aString ifNotNil: [
		self attributeAt: 'id' put: aString]! !

!WATagBrush methodsFor: '*seaside28jetsam-convenience' stamp: 'ul 6/24/2007 14:44'!
tooltip: stringOrTooltip
	"Using boxover, but only if current user wants them.
	See Q2StandardScripts>>boxover which is a slightly hacked/triimmed
	version of the original code. <stringOrTooltip> is either a String or
	a Q2BoxoverTooltip, see its class comment."

	stringOrTooltip ifNil: [^self].
	(Q2Session current noDb not and: [	Q2Session current currentUserSettings showToolTips]) ifFalse: [^self].
	^self title: (
		stringOrTooltip isString
			ifTrue: ['body=[', stringOrTooltip, ']']
			ifFalse: [ stringOrTooltip printString]) "then it must be a Q2BoxoverTooltip"! !

WASystemConfiguration subclass: #WAHelperConfiguration
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Configuration'!

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:28'!
attributeAXAnnouncer

	^ WABooleanAttribute key: #useAxAnnouncer group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:25'!
attributeAnnouncer

	^ WABooleanAttribute key: #useAnnouncer group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:19'!
attributeCometHelper

	^ WABooleanAttribute key: #enableCometHelper group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:10'!
attributeEnableShoreHelper

	^ WABooleanAttribute key: #enableShoreHelper group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 11/9/2007 23:59'!
attributeEnableToolbarHelper

	^ WABooleanAttribute key: #enableToolbarHelper group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 03:11'!
attributeKeepSessionAlive

	^ WABooleanAttribute key: #keepSessionAlive group: #helpers! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 14:50'!
attributes
	"thanks lukas"
	^ (self class selectors
		select: [ :each | each ~= #attributes
			and: [ each beginsWith: #attribute ] ])
		collect: [ :each | self perform: each ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentEnableCometHelper: value config: configuration
 
	^ value ifTrue: [ 'Comet support enabled for this application' ] ifFalse: [ 'enable to use Comet with this application' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentEnableShoreHelper: value config: configuration
 
	^ value ifTrue: [ 'ShoreComponents enabled for this application' ] ifFalse: [ 'enable to use ShoreComponents in this application' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentEnableToolbarHelper: value config: configuration
 
	^ value ifTrue: [ 'when deployed show toolbar for users with sessions having #showToolbarHelper flag set' ] ifFalse: [ 'enable to add toolbar for users with sessions having #showToolbarHelper flag set' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:36'!
commentKeepSessionAlive: value config: configuration
 
	^ value ifTrue: [ 'add javascript to every page which keeps the seaside session alive while the users browser is open' ] ifFalse: [ 'enable to add javascript to every page which keeps the seaside session alive while the users browser is open' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:37'!
commentUseAnnouncer: value config: configuration
 
	^ value ifTrue: [ 'sessions have #announcer' ] ifFalse: [ 'enable to add an Announcer to each Session' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 02:37'!
commentUseAxAnnouncer: value config: configuration
 
	^ value ifTrue: [ 'sessions have #axannouncer' ] ifFalse: [ 'enable to add an AXAnnouncer to each Session' ]! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:19'!
enableCometHelper

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 01:02'!
enableShoreHelper

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 11/10/2007 01:50'!
enableToolbarHelper

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 9/7/2007 14:53'!
keepSessionAlive

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:26'!
useAnnouncer

	^ false! !

!WAHelperConfiguration methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:29'!
useAxAnnouncer

	^ false! !

!WAResponse class methodsFor: '*seaside28jetsam-debugging-override' stamp: 'kph 1/29/2008 13:13'!
notFound: locationString

	(Preferences debugInternalErrors and: [ locationString ~= '/favicon.ico']) 
		ifTrue: [ self halt ].

	^ self new
		notFound;
		nextPutAll: '<h1> Error: "', locationString, '" not found. </h1>';
		yourself! !

!WAApplication methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 21:02'!
application
	^ self  ! !

!WAApplication methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 10/29/2007 04:37'!
handleDefaultRequest: aRequest
	"restoring the application: instanciation method, it is important that 
	setParent: is called before initialize, as all instanciation set methods should be!!"
	
	^ (self sessionClass application: self) handleRequest: aRequest! !

!WAApplication methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/8/2007 05:16'!
postProcessRequest: aRequest returned: aResponse

	^ (self sessionClass application: self) postProcessRequest: aRequest returned: aResponse! !

WAEntryPoint subclass: #FLFilesystemLink
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-FilesystemLink'!

!FLFilesystemLink class methodsFor: 'accessing' stamp: 'pmm 7/19/2007 18:29'!
description
	^ 'Filesystem Link'! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 20:26'!
asPathSting: aCollectionOfStrings
	^String streamContents: [ :stream |
		stream
			nextPutAll: self basePath.
		self basePath last = $/
			ifFalse: [ stream nextPut: $/ ].
		aCollectionOfStrings do: [ :each |
			stream
				nextPutAll: each;
				nextPut: $/ ] ].! !

!FLFilesystemLink methodsFor: 'accessing' stamp: 'pmm 7/19/2007 18:22'!
configurationComponent
	^FLHandlerEditor new
		link: self;
		yourself! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 19:19'!
documentAt: pathString filename: filenameString
	^WAResponse
			document: (SeasidePlatformSupport
				contentsOfFile: pathString
				binary: (WAFileLibrary isBinary: filenameString))
			mimeType: (WAFileLibrary mimetypeFor: (filenameString copyAfterLast: $.))! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 18:54'!
fullPathFor: aCollectionOfStrings
	^String streamContents: [ :stream |
		| delimeter |
		delimeter := SeasidePlatformSupport pathNameDelimiter.
		stream nextPutAll: self root.
		aCollectionOfStrings do: [ :each |
			stream
				nextPut: delimeter;
				nextPutAll: each ] ]
			! !

!FLFilesystemLink methodsFor: 'processing' stamp: 'pmm 7/19/2007 18:35'!
handleRequest: aRequest
	^ self
		responseAt: aRequest url
		ifAbsent: [ self notFound: aRequest url ]! !

!FLFilesystemLink methodsFor: 'testing' stamp: 'pmm 7/19/2007 18:38'!
isInitialized
	^self root isEmptyOrNil not! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 18:38'!
notFound: aString
	^ WAResponse notFound: aString! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 19:37'!
render: aOneArgumentBlock
	"convenvience method to render html
	aOneArgumentBlock will be passed an html canvas"
	^String streamContents: [ :stream |
		| newContext docRoot document renderer  |
		document := (WAHtmlStreamDocument new) stream: stream.
		newContext := WARenderingContext new document: document.
		docRoot := WAHtmlRoot context: newContext.
		renderer := WARenderCanvas context: newContext callbacks: Dictionary new.
		docRoot open: document.
		renderer context document stream: stream.
		aOneArgumentBlock value: renderer.
		renderer flush.
		docRoot close: document ]! !

!FLFilesystemLink methodsFor: 'rendering' stamp: 'pmm 7/19/2007 20:30'!
renderDirectory: aString on: html
	html tableRow: [
		html tableData: [
			html anchor
				url: (self webNameOf: aString);
				with: (SeasidePlatformSupport localNameOf: aString), '/' ] ]! !

!FLFilesystemLink methodsFor: 'rendering' stamp: 'pmm 7/19/2007 20:31'!
renderFile: aString on: html
	html tableRow: [
		html tableData: [
			html anchor
				url: (self webNameOf: aString);
				with: (SeasidePlatformSupport localNameOf: aString) ] ]! !

!FLFilesystemLink methodsFor: 'rendering' stamp: 'pmm 7/19/2007 20:27'!
renderHeading: aWebPath on: html
	html heading: (self asPathSting: aWebPath)
	! !

!FLFilesystemLink methodsFor: 'rendering' stamp: 'pmm 7/19/2007 20:34'!
renderListing: aFilesystemPath named: aWebPath
	| html |
	html := self render: [ :canvas |
		self renderHeading: aWebPath on: canvas.
		self renderUp: aWebPath on: canvas.
		canvas table: [
			(SeasidePlatformSupport directoriesIn: aFilesystemPath) do: [ :each |
				self renderDirectory: each on: canvas ].
			(SeasidePlatformSupport filesIn: aFilesystemPath) do: [ :each |
				self renderFile: each on: canvas ] ] ].
	^WAResponse
		document: html
		mimeType: 'text/html'
	! !

!FLFilesystemLink methodsFor: 'rendering' stamp: 'pmm 7/19/2007 20:36'!
renderUp: aWebPath on: html
	aWebPath isEmpty ifTrue: [ ^self ].

	html tableRow: [
		html tableData: [
			html text: '[ '.
			html anchor
				url: (self asPathSting: aWebPath allButLast);
				with: '..'. ].
			html text: ' ]'. ]! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 19:34'!
responseAt: aPath ifAbsent: aBlock
	| relativePath fullPath |
	self isInitialized ifFalse: [ ^aBlock value ].
	
	relativePath := (aPath allButFirst: self basePath size) findTokens: $/.
	fullPath := (self fullPathFor: relativePath).
	^(SeasidePlatformSupport existsFile: fullPath)
		ifTrue: [
			(SeasidePlatformSupport isDirectory: fullPath)
				ifTrue: [ self renderListing: fullPath named: relativePath ]
				ifFalse: [ self documentAt: fullPath filename: relativePath last ] ]
		ifFalse: [ self notFound: aPath ]! !

!FLFilesystemLink methodsFor: 'accessing' stamp: 'pmm 7/19/2007 18:23'!
root
	^root! !

!FLFilesystemLink methodsFor: 'accessing' stamp: 'pmm 7/19/2007 18:23'!
root: aString 
	root := aString! !

!FLFilesystemLink methodsFor: 'private' stamp: 'pmm 7/19/2007 20:29'!
webNameOf: aDirectoryPath
	^self asPathSting: ((aDirectoryPath allButFirst: self root size) findTokens: SeasidePlatformSupport pathNameDelimiter)
	! !

!WAKom class methodsFor: '*seaside28jetsam-override' stamp: 'kph 12/10/2007 05:10'!
startOn: aPort
	self stop.
	port := aPort.
	service := self createService.
	Preferences debugInternalErrors  ifTrue: [ service setDebugMode ].

	service start! !

!WAKom class methodsFor: '*seaside28jetsam-static files' stamp: 'cds 7/19/2007 22:32'!
startOn: aPort servingFilesFrom: rootPathString
	"Start a server on the specified port using the Comanche web server to serve static files from the specified
	directory.  All URL paths which begin with /seaside will be given to the seaside dispatcher.  All other path's
	will be treated as paths to files on the file system relative to the specified root path (rootPathString).  For 
	example, if you specify 'FileRoot' as the root path then an request to /images/someImage.png will serve the
	file FileRoot/images/someImage.png (where FileRoot should be a subdirectory of your squeak image directory).
	
	Note: if you use a relative path it is translated into an absolute one.  If you move you squeak image you 
	will probably have to restart the server.
	"
	| rootDirectoryFullPath ma |
	self stop.
	port := aPort.
	
	rootDirectoryFullPath := FileDirectory default fullNameFor: rootPathString.
	service := HttpService on: aPort named: 'seaside'.
	ma := ModuleAssembly core.
	ma alias: '/seaside' to: [ma addModule: self default].
	ma serverRoot: rootDirectoryFullPath.
	ma documentRoot: rootDirectoryFullPath.
	ma directoryIndex: 'index.html index.htm'.
	ma serveFiles.
	service plug: ma rootModule.
	service start.
! !

!WAKom methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 1/12/2009 21:17'!
handleRequest: aRequest
 
	 HttpAdaptor current addPostProcessor: [ :request :response | entryPoint postProcessRequest: request returned: response ].
	
	 ^ entryPoint handleRequest: aRequest! !

IdentityDictionary subclass: #WASessionHelpers
	instanceVariableNames: 'parent session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WASessionHelpers commentStamp: 'kph 12/9/2007 01:46' prior: 0!
Since WASession does not have a properties dictionary for flexible use, we provide a general purpose propteries container and we use this to support additional helper items for sessions.  

"The end may justify the means as long as there is something that justifies the end." -- Leon Trotsky

We maintain a back-link to the session for which our helpers are helping. If a helper wishes to work in collaboration with other helpers, it is able to hold a reference to the session or to us.!

!WASessionHelpers class methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 15:55'!
parent: aRequestHandler session: aSeasideSession

	^ self basicNew setParent: aRequestHandler session: aSeasideSession! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:47'!
actAsExecutor

	"since the session is likely to be the item registered for finalization, we must avoid holding on to references to it"
	session := nil.
	self keysAndValuesDo: [ :key :value | 
		value species == WASessionHelper ifTrue: [ self at: key put: value executor ]
	]! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 18:18'!
application
	^ parent! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 1/28/2008 22:09'!
executor
	"Return an object which can act as executor for finalization of the receiver"
	^self copy actAsExecutor! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:47'!
helpersDo: aBlock

	self do: [:each | each species == WASessionHelper ifTrue: [ aBlock value: each ] ]
	! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:44'!
incomingRequest: aRequest in: aSession

	self helpersDo: [ :each | 
		  (each incomingRequest: aRequest in: aSession) ifNotNilDo: [ :response | ^ response ]  
	].
	
	^ nil! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/28/2007 23:42'!
initialize
	super initialize: 5.
	WASessionHelper addHelpersTo: self! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:43'!
postProcessRequest: aRequest returned: aResponse

	self helpersDo: [ :each | each postProcessRequest: aRequest returned: aResponse ]! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:47'!
responseForRequest: aRequest wrap: aBlock

	"each helper gets the block which it can wrap, returning another block"
	
	| wrappedBlock |
	wrappedBlock := self inject: aBlock into: [ :block :each  | 
		each species == WASessionHelper ifTrue: [ each responseForRequest: aRequest wrap: block ] ifFalse: [ block ] 
	].
	
 	^ wrappedBlock value! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:12'!
session
	^ session! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:10'!
setParent: p session: s

	parent := p.
	session := s.! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:42'!
unregistered

	self helpersDo: [:each |  each unregistered ] ! !

!WASessionHelpers methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:50'!
updateRoot: aHtmlRoot

	self helpersDo: [ :each | each updateRoot: aHtmlRoot ]! !

!WACachedDocument methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 7/14/2007 12:29'!
clear
	

	"Clear the cached mimeDocument, will cause
	it to be re-read from disk at next access."

	
	mimeDocument _ nil! !

WACachedDocument subclass: #WANotCachedDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Document'!

!WANotCachedDocument class methodsFor: 'instance-creation' stamp: 'kph 7/14/2007 14:08'!
fileName: aFileName
	 
	^ self fullFileName: aFileName ! !

!WANotCachedDocument methodsFor: 'public' stamp: 'kph 7/14/2007 14:13'!
asMIMEDocumentType: type
	 
	 mimeDocument := nil.
	^ super asMIMEDocumentType: type! !

!WANotCachedDocument methodsFor: 'public' stamp: 'kph 7/14/2007 13:59'!
notCached

	^ true! !

!WAToolFrame methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/9/2007 23:43'!
on: html frameThis: aBlock

	self showHalos
		ifTrue: [ html context debugMode ].

	self timeThis: [ self withDeprecatedHandlerDo: aBlock ].
	
	html context clearMode! !

!WAToolFrame methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/9/2007 23:54'!
processTimeBegin
	processTime := Time millisecondClockValue.! !

!WAToolFrame methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/9/2007 23:40'!
timeThis: aBlock
	processTime := processTime isNil
		ifTrue: [ 0 ]
		ifFalse: [ Time millisecondClockValue - processTime ].
		
	renderTime := Time millisecondsToRun: aBlock.
! !

!WAFileHandler methodsFor: '*seaside28jetsam-libraries-override' stamp: 'kph 7/12/2007 10:13'!
libraryAt: aLibraryName ifAbsent: aBlock
	self librariesDo: [ :each |
 		(each libraryAt: aLibraryName) ifNotNilDo: [ :lib | ^ lib ] 
	].
	^ aBlock value! !

!WAFileHandler methodsFor: '*seaside28jetsam-libraries-override' stamp: 'kph 7/14/2007 09:56'!
responseAt: aPath ifAbsent: aBlock
	| libraryName fileName library |
	libraryName := aPath at: aPath size - 1.
	fileName := aPath last.

	library := self
		libraryAt: libraryName
		ifAbsent: [ ^ aBlock value ].
	^ library
		documentAt: fileName
		ifAbsent: aBlock! !

!WASession class methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/29/2007 04:40'!
application: anApplication
	"it is important that #setParent is called before initialize
	as all instanciation set methods should be for flexibility"
	
	^ self basicNew setParent: anApplication; initialize; yourself! !

!WASession class methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/13/2007 02:17'!
cleanUp

	WeakRegistry default in: [ :registry |
		(registry select: [ :each | each isKindOf: self ])
			do: [ :one | registry remove: one finalize ifAbsent: [] ] 
	].! !

!WASession class methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 2/3/2008 13:22'!
doesNotUnderstand: aMessage

	| appName |
	
	appName := aMessage selector upTo: $:.
	
	((WADispatcher default entryPoints includesKey: appName) and: [ aMessage selector isUnary ]) 
	ifTrue: [ ^ self forApp: appName ]
	ifFalse: [  ^ self forApp: appName during: aMessage arguments first ].
	
	^ super doesNotUnderstand: aMessage
 ! !

!WASession class methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/18/2007 19:12'!
forApp: appName 

	"this gets you command line access to the session outside of browser
	with the configuration of the named application"
	
	| app |

	app := WADispatcher default entryPointAt: appName.
	
	^ (app sessionClass application: app) registerForFinalization.
	
	 ! !

!WASession class methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/18/2007 19:41'!
forApp: appName during: aBlock

	| session |
 
	session := self forApp: appName.
	
	WACurrentSession use: session during: [  ^ session in: aBlock ]
	
	 ! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/11/2007 10:33'!
actAsExecutor

	super actAsExecutor.	
	parent := parent executor.
				
	^ self! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 19:42'!
announcer
	^ self helpers at: #announcer! !

!WASession methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 10/27/2007 18:18'!
application
	^ parent application! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 20:24'!
axannouncer
	^ self helpers at: #axannouncer! !

!WASession methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 10/30/2007 03:39'!
baseUrl
	^ self application baseUrl! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 21:28'!
comet
	^ self helpers at: #comet ifAbsent: nil! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 18:25'!
expire
	"we unregister the helpers at expire time, rather than waiting for the session to be cleaned up later"
	self helpers unregistered! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/18/2007 19:15'!
finalize

	^ self unregistered! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 22:53'!
helpers
	"shh dont tell anyone"
	^ parent! !

!WASession methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 12/8/2007 03:20'!
incomingRequest: aRequest
 	
	(self helpers incomingRequest: aRequest in: self) ifNotNilDo: [ :response | ^ response ].
 	
	((aRequest fields includesKey: 'terminate')
		and: [(self application deploymentMode not or: [ self showToolbarHelper ])])
			ifTrue: [
				monitor terminate.
				^ WAResponse new nextPutAll: 'Process terminated' ].
	^ monitor
		critical: [ self responseForRequest: aRequest ]
		ifError: [ :error | self errorHandler internalError: error ]
		
	 ! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/16/2008 20:25'!
postProcessRequest: aRequest returned: aResponse

	monitor
		critical: [
			
		WACurrentSession
			use: self
			during: [self postServeBlocksExecute.
				  self helpers postProcessRequest: aRequest returned: aResponse ]
	
		] ifError: [ :error | self log seaside error miscError: error ]
		! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/28/2008 09:57'!
postServeBlocks
	
	^ self properties at: #postServeBlocks ifAbsentPut: [ OrderedCollection new ] ! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/28/2008 11:58'!
postServeBlocksExecute
 
	[ self postServeBlocks do: [ :ea | ea value ] ] 
	ensure: [
		self properties removeKey: #postServeBlocks ifAbsent: nil 
	]! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/27/2007 22:56'!
properties

	"our extension to WASession provides an IdentityDictionary for storing Property values"

	"shh dont tell anyone"
	^ parent! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/11/2007 10:25'!
registerForFinalization
	
	self finalizationRegistry add: self executor:  self executor..! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/8/2007 05:19'!
registerPusher: aPusher context: aContext

	"CTComet could be changed to send this, in order that this method be removed from WASession"
	^ self comet registerPusher: aPusher context: aContext! !

!WASession methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 12/9/2007 05:30'!
responseForRequest: aRequest
	| response |
	currentRequest := aRequest.
	response := self helpers responseForRequest: aRequest wrap: [  self withEscapeContinuation: [
		WACurrentSession
			use: self
			during: [
				self withErrorHandler: [
					self performRequest: aRequest ] ] ]].
	
	response headerAt: 'Session' put: (self application ensureKeyForHandler: self) printString.
	
	^ response! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/31/2007 04:17'!
rootComponent

	^ lastContinuation root! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/11/2007 15:56'!
setParent: aRequestHandler
	
	parent := WASessionHelpers parent: aRequestHandler session: self.
	parent initialize.		 ! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/10/2007 00:54'!
showToolbarHelper
	
	^ self properties at: #showToolbarhelper ifAbsent: [ false ] ! !

!WASession methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 11/10/2007 01:03'!
showToolbarHelper: aBool
	
	self properties at: #showToolbarhelper put: aBool! !

!WASession methodsFor: '*seaside28jetsam-helpers-override' stamp: 'lr 4/15/2007 15:55'!
unregistered
	super unregistered.
	self expire! !

!WASession methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 2/25/2008 14:14'!
updateRoot: anHtmlRoot
	self application updateRoot: anHtmlRoot.
	anHtmlRoot meta contentType: self contentType charset: self charSet.
	anHtmlRoot meta responseHeaderName: 'Content-Script-Type'; content: 'text/javascript'.
	anHtmlRoot htmlAttributes
		at: 'xmlns' put: 'http://www.w3.org/1999/xhtml';
		at: 'xml:lang' put: 'en';
		at: 'lang' put: 'en'.
	anHtmlRoot beXhtml10Strict.
	anHtmlRoot title: 'Seaside'.
	self helpers updateRoot: anHtmlRoot.! !

!WAUrl class methodsFor: '*seaside28jetsam-libraries' stamp: 'kph 8/23/2007 16:28'!
fromString: a

	| url | 
	
	url := Url absoluteFromText: a.
	
	^ (self new)
			scheme: url scheme;
			hostname: url authority;
			port: url port;
			path: url path;
			yourself
			 
		 ! !

WAFormDialog subclass: #WAPluggableDialog
	instanceVariableNames: 'block cssClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Dialogs'!

!WAPluggableDialog class methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2008 02:19'!
renderBlock: aBlock

	^ self new renderBlock: aBlock; yourself! !

!WAPluggableDialog methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2008 02:42'!
cssClass
	^ cssClass ifNil: [ super cssClass ]! !

!WAPluggableDialog methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2008 02:42'!
cssClass: c

	cssClass := c! !

!WAPluggableDialog methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2008 02:46'!
divClass
	^ cssClass ifNil: [ super cssClass ]! !

!WAPluggableDialog methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2008 02:18'!
renderBlock: aBlock

	block := aBlock! !

!WAPluggableDialog methodsFor: 'as yet unclassified' stamp: 'kph 2/26/2008 02:20'!
renderDialogOn: html

	block value: html! !

WAFunctionalTest subclass: #WAStandardFilesPlusTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Tests-Functional'!

!WAStandardFilesPlusTest methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:41'!
label

^ 'File Handler+'! !

!WAStandardFilesPlusTest methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:35'!
renderContentOn: html

html text: 'This image is: inspector.png, to test place your own version in the local directory '' seaside''.'.
html image url: (WAStandardFilesPlus / 'inspector.png')! !

WADynamicVariable subclass: #WACurrentUser
	instanceVariableNames: ''
	classVariableNames: 'DefaultUser'
	poolDictionaries: ''
	category: 'Seaside28Jetsam-CurrentUser'!

!WACurrentUser methodsFor: 'as yet unclassified' stamp: 'kph 10/24/2007 02:51'!
defaultValue

	^ nil
 ! !

!WACurrentUser methodsFor: 'as yet unclassified' stamp: 'kph 10/24/2007 03:15'!
preferenceAt: key

	| user |
	
	user := self value.
	
	"replace with askFor: when it is available in the kernel"
	(user respondsTo: key) ifFalse: [ ^ WACurrentSession value application preferenceAt: key ].
	
	^ user perform: key! !

WAStandardFiles subclass: #WAStandardFilesPlus
	instanceVariableNames: 'fileNames directory fileSelectors'
	classVariableNames: 'Instances'
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Libraries'!

!WAStandardFilesPlus commentStamp: 'kph 7/19/2007 20:24' prior: 0!
The majority of seaside projects need to have WAStandardFiles included otherwise such things as the toolbar cease to display properly.

This class inherits from WAStandardFiles and so by subclassing me, and adding your subclass to your project (e.g. MyFiles)
you can override the defaults. I also add some features.

Note the following example, in which the filename may be used to reference a file in your generation code.

html image url: (MyFiles / 'logo.gif').

In standard seaside the file selector form #logoGif would be used. In a shameless hack which would never be accepted in seaside proper, we enable both forms. A symbol is assumed to be a selector reference, and a string is assumed to be a file reference. We do this simply because, in situations where you may be asking a user to specify a file via a settings interface, they are likely to be more familiar with the filename form. The filename form is also cannonical.

Your subclass can also specify whether or not it caches DISK (i.e. not those stored in a file library method selector aka WAStandardFiles) based documents, by defining #documentClass. By default we serve non-cached documents (i.e. we do not cache the document, and we request that the browser does not either), but once your project is defined you may wish to change that.

We keep a cache the fileNames of those files we have available to serve from disk.
In an extra-ordinary hack we reset this cache whenever #miscJs is accessed which is likely to happen once per user session. This may not be appropriate and better ideas are very welcome!!


!

!WAStandardFilesPlus class methodsFor: 'generating html' stamp: 'kph 8/3/2007 08:07'!
/ aSymbolOrFileNameString

	aSymbolOrFileNameString isSymbol 
		ifTrue: [ ^ self default urlOf: aSymbolOrFileNameString ]
		ifFalse: [ ^ self default urlForFile: aSymbolOrFileNameString ]! !

!WAStandardFilesPlus class methodsFor: 'generating html' stamp: 'sas 8/23/2007 14:31'!
libraryName

	^ self name asString! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 06:36'!
baseUrl

	^ self baseUrlPreference "self baseUrlDefault"! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 04:05'!
documentAt: aFilename ifAbsent: aBlock
	
	| doc response |
  
	(self fileNames includes: aFilename) 
		ifFalse: [ ^ super documentAt: aFilename ifAbsent: aBlock ].
 
	doc := (self documentClass
			fileName:  (self libraryName, FileDirectory slash , aFilename)) asMIMEDocument.
	 
	response := WAResponse new.
	response contents: doc contentStream text.
	response contentType: doc mimeType.
 
	(doc respondsTo: #notCached) 
		ifTrue: [ response doNotCache ]
		ifFalse: [ response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT' ].

 	response attachmentWithFileName: aFilename.

	^ response! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 2/6/2008 11:45'!
documentClass
	
	^ WANotCachedDocument

	"or WANotCachedDocument"
 ! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:33'!
fileNames

	| dir |

	^ fileNames ifNil: [ 

		(dir := self libraryDirectory) exists ifFalse:[ ^ #() ].

		fileNames := dir fileNames 
	].! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 9/28/2007 03:16'!
fileSelectors
	"we inherit and cache our fileSelectors whereas standard file libraries do not."
 
	^ fileSelectors ifNil:[ self initializeFileSelectors ]! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:17'!
initialize


 ! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 11/19/2007 04:04'!
initializeFileSelectors
 
	^ fileSelectors := (((self class withAllSuperclasses upTo: WAFileLibrary) 
			gather:[:aClass | aClass selectors])
				select: [ :each | self isFileSelector: each ])  
										difference: self nonFileSelectors   ! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 19:32'!
libraryDirectory

	^ directory ifNil: [ directory := FileDirectory default directoryNamed: self libraryName ]! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 20:24'!
miscJs

	fileNames := nil.
	fileSelectors := nil.

	^ super miscJs! !

!WAStandardFilesPlus methodsFor: 'as yet unclassified' stamp: 'sas 8/29/2007 23:02'!
nonFileSelectors
	^super nonFileSelectors,#(
		documentClass
		fileNames
		fileSelectors
		initialize
		libraryDirectory
		libraryName
		nonFileSelectors
		selectorsToInclude
		baseUrl
		initializeFileSelectors
	)! !

Object subclass: #WACountries
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Useful-Data'!

!WACountries class methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 10:18'!
AtoK

 ^ { 

         'LA' -> 'Lao People''s Democratic Republic'.
            'LV' -> 'Latvia'.
            'LB' -> 'Lebanon'.
            'LS' -> 'Lesotho'. 
            'LR' -> 'Liberia'. 
            'LY' -> 'Libyan Arab Jamahiriya'.
            'LI' -> 'Liechtenstein'. 
            'LT' -> 'Lithuania'.
            'LU' -> 'Luxembourg'.
                     'MO' -> 'Macau'. 
            'MK' -> 'Macedonia. The Former Yugoslav Republic of'.
            'MG' -> 'Madagascar'.
            'MW' -> 'Malawi'.
            'MY' -> 'Malaysia'.
            'MV' -> 'Maldives'.
            'ML' -> 'Mali'.
            'MT' -> 'Malta'.
            'MH' -> 'Marshall Islands'.
            'MQ' -> 'Martinique'.
            'MR' -> 'Mauritania'.
            'MU' -> 'Mauritius'.
            'YT' -> 'Mayotte'. 
            'MX' -> 'Mexico'.
            'FM' -> 'Micronesia. Federated States of'.
            'MD' -> 'Moldova. Republic of'.
            'MC' -> 'Monaco'.
            'MN' -> 'Mongolia'.
            'MS' -> 'Montserrat'.
            'MA' -> 'Morocco'.
            'MZ' -> 'Mozambique'.
            'MM' -> 'Myanmar'.
            'NA' -> 'Namibia'.
            'NR' -> 'Nauru'. 
            'NP' -> 'Nepal'. 
            'NL' -> 'Netherlands'.
            'AN' -> 'Netherlands Antilles'.
            'NC' -> 'New Caledonia'.
            'NZ' -> 'New Zealand'. 
            'NI' -> 'Nicaragua'. 
            'NE' -> 'Niger'. 
            'NG' -> 'Nigeria'. 
            'NU' -> 'Niue'.
            'NF' -> 'Norfolk Island'.
            'MP' -> 'Northern Mariana Islands'.
            'NO' -> 'Norway'.
            'OM' -> 'Oman'.
            'PK' -> 'Pakistan'.
            'PW' -> 'Palau'.
            'PA' -> 'Panama'.
            'PG' -> 'Papua New Guinea'.
            'PY' -> 'Paraguay'.
            'PE' -> 'Peru'.
            'PH' -> 'Philippines'.
            'PN' -> 'Pitcairn'.
            'PL' -> 'Poland'.
            'PT' -> 'Portugal'.
            'PR' -> 'Puerto Rico'.
            'QA' -> 'Qatar'.
            'RE' -> 'Reunion'.
            'RO' -> 'Romania'.
            'RU' -> 'Russian Federation'.
            'RW' -> 'Rwanda'.
            'KN' -> 'Saint Kitts and Nevis'. 
            'LC' -> 'Saint LUCIA'. 
            'VC' -> 'Saint Vincent and the Grenadines'.
            'WS' -> 'Samoa'. 
            'SM' -> 'San Marino'.
            'ST' -> 'Sao Tome and Principe'.
            'SA' -> 'Saudi Arabia'.
            'SN' -> 'Senegal'.
            'SC' -> 'Seychelles'.
            'SL' -> 'Sierra Leone'.
            'SG' -> 'Singapore'. 
            'SK' -> 'Slovakia (Slovak Republic)'.
            'SI' -> 'Slovenia'.
            'SB' -> 'Solomon Islands'.
            'SO' -> 'Somalia'. 
            'ZA' -> 'South Africa'.
            'GS' -> 'South Georgia and the South Sandwich Islands'.
            'ES' -> 'Spain'.
            'LK' -> 'Sri Lanka'.
            'SH' -> 'St. Helena'.
            'PM' -> 'St. Pierre and Miquelon'. 
            'SD' -> 'Sudan'. 
            'SR' -> 'Suriname'.
            'SJ' -> 'Svalbard and Jan Mayen Islands'.
            'SZ' -> 'Swaziland'. 
            'SE' -> 'Sweden'.
            'CH' -> 'Switzerland'. 
            'SY' -> 'Syrian Arab Republic'.
            'TW' -> 'Taiwan. Province of China'.
            'TJ' -> 'Tajikistan'.
            'TZ' -> 'Tanzania. United Republic of'.
            'TH' -> 'Thailand'.
            'TG' -> 'Togo'.
            'TK' -> 'Tokelau'.
            'TO' -> 'Tonga'. 
            'TT' -> 'Trinidad and Tobago'. 
            'TN' -> 'Tunisia'. 
            'TR' -> 'Turkey'.
            'TM' -> 'Turkmenistan'.
            'TC' -> 'Turks and Caicos Islands'.
            'TV' -> 'Tuvalu'.
            'UG' -> 'Uganda'.
            'UA' -> 'Ukraine'.
            'AE' -> 'United Arab Emirates'.
            'GB' -> 'United Kingdom'.
            'US' -> 'United States'.
            'UM' -> 'United States Minor Outlying Islands'.
            'UY' -> 'Uruguay'. 
            'UZ' -> 'Uzbekistan'.
            'VU' -> 'Vanuatu'. 
            'VE' -> 'Venezuela'.
            'VN' -> 'Viet Nam'.
            'VG' -> 'Virgin Islands (British)'.
            'VI' -> 'Virgin Islands (U.S.)'. 
            'WF' -> 'Wallis and Futuna Islands'. 
            'EH' -> 'Western Sahara'.
            'YE' -> 'Yemen'. 
            'YU' -> 'Yugoslavia'.
            'ZM' -> 'Zambia'.
            'ZW' -> 'Zimbabwe'    
   
}! !

!WACountries class methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 10:19'!
LtoZ

 ^ { 

         'LA' -> 'Lao People''s Democratic Republic'.
            'LV' -> 'Latvia'.
            'LB' -> 'Lebanon'.
            'LS' -> 'Lesotho'. 
            'LR' -> 'Liberia'. 
            'LY' -> 'Libyan Arab Jamahiriya'.
            'LI' -> 'Liechtenstein'. 
            'LT' -> 'Lithuania'.
            'LU' -> 'Luxembourg'.
                     'MO' -> 'Macau'. 
            'MK' -> 'Macedonia. The Former Yugoslav Republic of'.
            'MG' -> 'Madagascar'.
            'MW' -> 'Malawi'.
            'MY' -> 'Malaysia'.
            'MV' -> 'Maldives'.
            'ML' -> 'Mali'.
            'MT' -> 'Malta'.
            'MH' -> 'Marshall Islands'.
            'MQ' -> 'Martinique'.
            'MR' -> 'Mauritania'.
            'MU' -> 'Mauritius'.
            'YT' -> 'Mayotte'. 
            'MX' -> 'Mexico'.
            'FM' -> 'Micronesia. Federated States of'.
            'MD' -> 'Moldova. Republic of'.
            'MC' -> 'Monaco'.
            'MN' -> 'Mongolia'.
            'MS' -> 'Montserrat'.
            'MA' -> 'Morocco'.
            'MZ' -> 'Mozambique'.
            'MM' -> 'Myanmar'.
            'NA' -> 'Namibia'.
            'NR' -> 'Nauru'. 
            'NP' -> 'Nepal'. 
            'NL' -> 'Netherlands'.
            'AN' -> 'Netherlands Antilles'.
            'NC' -> 'New Caledonia'.
            'NZ' -> 'New Zealand'. 
            'NI' -> 'Nicaragua'. 
            'NE' -> 'Niger'. 
            'NG' -> 'Nigeria'. 
            'NU' -> 'Niue'.
            'NF' -> 'Norfolk Island'.
            'MP' -> 'Northern Mariana Islands'.
            'NO' -> 'Norway'.
            'OM' -> 'Oman'.
            'PK' -> 'Pakistan'.
            'PW' -> 'Palau'.
            'PA' -> 'Panama'.
            'PG' -> 'Papua New Guinea'.
            'PY' -> 'Paraguay'.
            'PE' -> 'Peru'.
            'PH' -> 'Philippines'.
            'PN' -> 'Pitcairn'.
            'PL' -> 'Poland'.
            'PT' -> 'Portugal'.
            'PR' -> 'Puerto Rico'.
            'QA' -> 'Qatar'.
            'RE' -> 'Reunion'.
            'RO' -> 'Romania'.
            'RU' -> 'Russian Federation'.
            'RW' -> 'Rwanda'.
            'KN' -> 'Saint Kitts and Nevis'. 
            'LC' -> 'Saint LUCIA'. 
            'VC' -> 'Saint Vincent and the Grenadines'.
            'WS' -> 'Samoa'. 
            'SM' -> 'San Marino'.
            'ST' -> 'Sao Tome and Principe'.
            'SA' -> 'Saudi Arabia'.
            'SN' -> 'Senegal'.
            'SC' -> 'Seychelles'.
            'SL' -> 'Sierra Leone'.
            'SG' -> 'Singapore'. 
            'SK' -> 'Slovakia (Slovak Republic)'.
            'SI' -> 'Slovenia'.
            'SB' -> 'Solomon Islands'.
            'SO' -> 'Somalia'. 
            'ZA' -> 'South Africa'.
            'GS' -> 'South Georgia and the South Sandwich Islands'.
            'ES' -> 'Spain'.
            'LK' -> 'Sri Lanka'.
            'SH' -> 'St. Helena'.
            'PM' -> 'St. Pierre and Miquelon'. 
            'SD' -> 'Sudan'. 
            'SR' -> 'Suriname'.
            'SJ' -> 'Svalbard and Jan Mayen Islands'.
            'SZ' -> 'Swaziland'. 
            'SE' -> 'Sweden'.
            'CH' -> 'Switzerland'. 
            'SY' -> 'Syrian Arab Republic'.
            'TW' -> 'Taiwan. Province of China'.
            'TJ' -> 'Tajikistan'.
            'TZ' -> 'Tanzania. United Republic of'.
            'TH' -> 'Thailand'.
            'TG' -> 'Togo'.
            'TK' -> 'Tokelau'.
            'TO' -> 'Tonga'. 
            'TT' -> 'Trinidad and Tobago'. 
            'TN' -> 'Tunisia'. 
            'TR' -> 'Turkey'.
            'TM' -> 'Turkmenistan'.
            'TC' -> 'Turks and Caicos Islands'.
            'TV' -> 'Tuvalu'.
            'UG' -> 'Uganda'.
            'UA' -> 'Ukraine'.
            'AE' -> 'United Arab Emirates'.
            'GB' -> 'United Kingdom'.
            'US' -> 'United States'.
            'UM' -> 'United States Minor Outlying Islands'.
            'UY' -> 'Uruguay'. 
            'UZ' -> 'Uzbekistan'.
            'VU' -> 'Vanuatu'. 
            'VE' -> 'Venezuela'.
            'VN' -> 'Viet Nam'.
            'VG' -> 'Virgin Islands (British)'.
            'VI' -> 'Virgin Islands (U.S.)'. 
            'WF' -> 'Wallis and Futuna Islands'. 
            'EH' -> 'Western Sahara'.
            'YE' -> 'Yemen'. 
            'YU' -> 'Yugoslavia'.
            'ZM' -> 'Zambia'.
            'ZW' -> 'Zimbabwe'    
   
}! !

!WACountries class methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 10:19'!
value

^ self AtoK , self LtoZ
! !

Object subclass: #WACreditCard
	instanceVariableNames: 'number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-CreditCard'!

!WACreditCard commentStamp: 'kph 12/18/2007 01:57' prior: 0!
Credit card validation

Ruby Version: Lucas Carlson  (mailto:lucas@rufy.com)
See: rubygems CreditCard.

Original Perl Version by Jon Orwant and Ivan Kohler
http://search.cpan.org/~ivan/Business-CreditCard-0.28/CreditCard.pm

 
	WACreditCard types.  #(#mastercard #visa #americanExpress #dinersClub #enroute #discover #jcb #bankcard #switch #solo)
		
	(WACreditCard number: '5276 4400 6542 1319') isCreditCard. 
	 
	(WACreditCard number: '5276 4400 6542 1319') is: #mastercard. 

== References
 - http://perl.about.com/compute/perl/library/nosearch/P073000.htm
 - http://www.beachnet.com/~hstiles/cardtype.html!

!WACreditCard class methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 21:56'!
number: stringWithCreditCardNumber

	^ self basicNew setNumber: stringWithCreditCardNumber; yourself ! !

!WACreditCard class methodsFor: 'as yet unclassified' stamp: 'kph 12/18/2007 01:57'!
types
							"prefix"			"length"
  ^	#( #mastercard			"51-55			 16"
	#visa 					"4 				 13, 16"
	#americanExpress		"34, 37 			 15"
	#dinersClub 			"300-305, 36, 38 	 14"
	#enroute 				"2014, 2149 		 15"
	#discover 				"6011 			 16"
	#jcb 					"3 				 16
 			                    2131, 1800 		 15"
	#bankcard 				"5610, 56022[1-5]  16"
	#switch                    "various 		  16,18,19"
	#solo )                      "63, 6767		  16,18,19|"! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:41'!
americanExpress

	self isValid ifFalse: [ ^ false ].

	number size = 15 ifFalse: [ ^ false ].

	number first = $3 ifFalse: [ ^ false ].
	
	(#($4 $7) includes: number second) ifFalse:[ ^ false ].
	
	^ true! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 00:06'!
amex

	^ self americanExpress! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:41'!
bankcard 			 
	 			"5610, 56022[1-5]  16"
	self isValid ifFalse: [ ^ false ].

	number size = 16 ifFalse: [ ^ false ].

	(number beginsWith: '5610') ifTrue: [ ^ true  ].
 
	((number beginsWith: '56022') and: [ number sixth between: $0 and: $5 ]) ifTrue: [ ^ true  ].
 
	^ false! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
dinersClub
	"/^3(0[0-5]|[68]\d)\d{11}$/"
	self isValid ifFalse: [ ^ false ].

	(14 = number size) ifFalse: [ ^ false ].
	
	number first = $3 ifFalse: [ ^ false ].
	
	number second = $0 
		ifTrue: [ (number third between: $0 and: $5) ifFalse: [ ^ false ] ].

	(#($6 $8) includes: number second) ifFalse: [ ^ false ].
	
 	^ true! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
discover

	self isValid ifFalse: [ ^ false ].

	number size = 16 ifFalse: [ ^ false ].

	(number beginsWith: '6011') ifFalse: [ ^ false ].
 
	^ true! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
enroute 			 

	self isValid ifFalse: [ ^ false ].

	number size = 15 ifFalse: [ ^ false ].

	((number beginsWith: '2014')  or: [ number beginsWith: '2149' ]) ifTrue: [ ^ true  ].
 
	^ false! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/17/2007 22:56'!
is: type

	^ self perform: type
! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:40'!
isValid

	| sum |
	
	number size < 13 ifTrue: [ ^ false ].
	
	sum := 0.
	0 to: number size do: [ :i  |
			| weight idx  |
			idx := 1 + number size + (-1*(i+2)).

			weight := ((idx between: 1 and: number size)
				ifTrue: [ (number at: idx) asInteger - 48 ] 
				ifFalse: [ 0 ]) *  (2 - (i rem: 2)).
			sum := sum + (weight < 10 ifTrue: [ weight ] ifFalse: [  weight - 9 ]).
	].

	^ (number last asInteger - 48) = ((10 - (sum rem: 10)) rem: 10)
	! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
jcb 			 
	 						"3 				 16
 			                    2131, 1800 		 15"
	self isValid ifFalse: [ ^ false ].

	(number size = 16 and: [ number first = $3 ]) ifTrue: [ ^ true ].

	number size = 15 ifFalse: [ ^ false ].
	
	((number beginsWith: '2131')  or: [ number beginsWith: '1800' ]) ifTrue: [ ^ true  ].
 
	^ false! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
mastercard

	self isValid ifFalse: [ ^ false ].

	number size = 16 ifFalse: [ ^ false ].

	number first = $5 ifFalse: [ ^ false ].
	
	(number second between: $1 and: $5) ifFalse: [ ^ false ].
	
	^ true ! !

!WACreditCard methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 23:05'!
number
 
	^ number  ! !

!WACreditCard methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 21:52'!
setNumber: aString
 
	number := aString select: [ :each | each isDigit ]! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
solo                     "63, 6767		  16,18,19|"

	self isValid ifFalse: [ ^ false ].

	(#(16 18 19) includes: number size) ifFalse: [ ^ false ].

	((number beginsWith: '6334') and: [ number fifth <= $5  ]) ifTrue: [ ^ true  ].
	(number beginsWith: '6767') ifTrue: [ ^ true  ].
 
	^ false 
 ! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:42'!
switch                 
 "/^49(03(0[2-9]|3[5-9])|11(0[1-2]|7[4-9]|8[1-2])|36[0-9]{2})\d{10}(\d{2,3})?$/ || number =~ /^564182\d{10}(\d{2,3})?$/ || number =~ /^6(3(33[0-4][0-9])|759[0-9]{2})\d{10}(\d{2,3})?$/"
	self isValid ifFalse: [ ^ false ].

	(#(16 18 19) includes: number size) ifFalse: [ ^ false ].

	((number beginsWith: '49030') and: [ number sixth >= $2  ]) ifTrue: [ ^ true ].

	((number beginsWith: '49033') and: [ number sixth >= $5  ]) ifTrue: [ ^ true ].
	
	((number beginsWith: '491101') or: [ number beginsWith: '491102']) ifTrue: [ ^ true ].

	((number beginsWith: '497') and: [ number fourth >= $4]) ifTrue: [ ^ true ].
	
	((number beginsWith: '4981') or: [ number beginsWith: '4982']) ifTrue: [ ^ true ].
		
	(number beginsWith: '4936') ifTrue: [ ^ true ] .
 
	(number beginsWith: '564182') ifTrue: [ ^ true ].
	
	((number beginsWith: '6333') and: [ number fifth <= $4])  ifTrue: [ ^ true ].
	(number beginsWith: '63759') ifTrue: [ ^ true ].
	 
 
	^ false 
 ! !

!WACreditCard methodsFor: 'public' stamp: 'kph 12/18/2007 22:43'!
visa

	self isValid ifFalse: [ ^ false ].

	(#(13 16) includes: number size) ifFalse: [ ^ false ].

	number first = $4 ifFalse: [ ^ false ].
	
 	^ true! !

Object subclass: #WADebugging
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Debugging'!

!WADebugging commentStamp: 'kph 4/22/2008 02:49' prior: 0!
Initialize Squeak preferences panel. !

!WADebugging class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 02:49'!
initialize
 
	self preferences.! !

!WADebugging class methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 06:46'!
categories

^ #('seaside debug')! !

!WADebugging class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 02:49'!
preferenceDebugInternalErrors
 
	Preferences addBooleanPreference: #debugInternalErrors categories: self categories default: false balloonHelp: 'Enable halt on internal error (restart Kom to take effect)'.
		! !

!WADebugging class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 02:48'!
preferences
	(self class selectors
		select: [ :each | each ~= #preferences
			and: [ each beginsWith: #pref ] ])
		do: [ :each | self perform: each ]
 ! !

!WADebugging class methodsFor: 'as yet unclassified' stamp: 'kph 4/22/2008 02:52'!
preferencesDebugErrors
 
	Preferences addBooleanPreference: #helpfulErrors categories: self categories default: false balloonHelp: 'Enable helpful errors. (See senders of #helpfulError:)'.
		
	Preferences addBooleanPreference: #haltOnForbidden categories:  self categories default: false balloonHelp: 'Halt when user accesses a forbidden page'.
			
! !

Object subclass: #WAJs
	instanceVariableNames: 'js'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Useful-JS'!

WAJs class
	instanceVariableNames: 'soleInstance'!

WAJs class
	instanceVariableNames: 'soleInstance'!

!WAJs class methodsFor: 'as yet unclassified' stamp: 'kph 4/3/2008 19:43'!
all
	soleInstance ifNil: [ ^ self generate js contents ].
	^ soleInstance js contents 
  ! !

!WAJs class methodsFor: 'as yet unclassified' stamp: 'kph 2/25/2008 02:51'!
freeSomeSpace

	self resetCache! !

!WAJs class methodsFor: 'as yet unclassified' stamp: 'kph 2/25/2008 02:55'!
generate 

	soleInstance := self new.
	
	((self allSelectorsBelow: WAJs) 
		select: [ :sel | sel beginsWith: #js ]) asSortedCollection 
		do: [ :sel |  soleInstance perform: sel ].
		
	^ soleInstance! !

!WAJs class methodsFor: 'as yet unclassified' stamp: 'kph 6/2/2008 21:17'!
onChanged
	"this little trick ensures that any changes to the css methods invalidate the cache"
	
	self withAllSubclassesDo: [ :each | each resetCache ].
	 
 ! !

!WAJs class methodsFor: 'as yet unclassified' stamp: 'kph 2/25/2008 02:49'!
resetCache
 
	soleInstance := nil.! !

!WAJs methodsFor: 'as yet unclassified' stamp: 'kph 6/2/2008 22:44'!
initialize

	js := String new writeStream! !

!WAJs methodsFor: 'as yet unclassified' stamp: 'kph 2/25/2008 02:47'!
js

	^ js ! !

WAJs subclass: #WAUsefulSnippetsJS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Useful-JS'!

Object subclass: #WASessionHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

WASessionHelper subclass: #WAAXAnnouncementsHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WAAXAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:58'!
helperKey

	^ #axannouncer! !

!WAAXAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:27'!
isEnabledFor: application

	^ (application preferenceAt: #useAXAnnouncer) ifNil: [ false ]! !

!WAAXAnnouncementsHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:00'!
helperValue

	^ (Smalltalk at: #AXAnnouncer ifAbsent: 'AXAnnouncements package not loaded') new! !

WASessionHelper subclass: #WAAnnouncementsHelper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WAAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:58'!
helperKey

	^ #announcer! !

!WAAnnouncementsHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:27'!
isEnabledFor: application

	^ (application preferenceAt: #useAnnouncer) ifNil: [ false ]! !

!WAAnnouncementsHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 20:00'!
helperValue

	^ (Smalltalk at: #Announcer ifAbsent: 'Announcements package not loaded') new! !

WASessionHelper subclass: #WACometHelper
	instanceVariableNames: 'handlers session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Helpers-Session'!

!WACometHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:59'!
helperKey

	^ #comet! !

!WACometHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:18'!
isEnabledFor: application

	^ (application preferenceAt: #enableCometHelper) ifNil: [ false ]! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 10:36'!
actAsExecutor

	"if you reference the seaside session it nust be nilled out here."
		super actAsExecutor.
		session := nil.! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:00'!
handlerClass
	^ Smalltalk at: #CTHandler ifAbsent: [ self error: 'comet package not loaded' ]! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:21'!
headerField
	^ '_c'! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 21:52'!
incomingRequest: aRequest in: aSession

	aRequest responseStream
		ifNil: [ self error: 'Streaming-server required to support Comet' ].

	^  (handlers at: (aRequest fields at: self headerField ifAbsent: [ ^ nil ]) ifAbsent: [ ^ nil ]) connect: aRequest ! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:50'!
initialize
	handlers := Dictionary new! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:46'!
isRequestHandler

	^ true! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:17'!
registerPusher: aPusher context: aContext
	| handler |
	handler := self handlerClass on: aPusher session: session context: aContext.
	handlers at: handler id put: handler.
	^ handler id
 ! !

!WACometHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:51'!
setUp: helpers
	 	session := helpers session.! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:49'!
addHelpersTo: helpers 
	self allSubclasses 
		do: [:each | (each isEnabledFor: helpers application) ifTrue: [each new addHelperTo: helpers; setUp: helpers ]].
	^ helpers! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 09:37'!
doesNotUnderstand: aMessage

	aMessage selector isUnary ifTrue: [ ^ self forApp: aMessage selector ].
	
	^ super doesNotUnderstand: aMessage.
! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 09:37'!
forApp: appName 

	"this gets you DIRECT command line access to the helper outside of browser
	with the configuration of the named application"
	
	^ (WASession forApp: appName) helpers at: self helperKey 
	 ! !

!WASessionHelper class methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 19:18'!
isEnabledFor: application 
	self subclassResponsibility! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/11/2007 10:36'!
actAsExecutor

	"if you reference the seaside session it nust be nilled out here."
	super actAsExecutor! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/28/2007 23:44'!
addHelperTo: helpers

	helpers at: self helperKey put: self helperValue! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/17/2007 00:57'!
helperKey

	^ self class helperKey! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 19:56'!
helperValue

	^ self! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:48'!
incomingRequest: aRequest in: aSession

	^ nil! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:48'!
initialize
	"called before adding the helper to the session #setUp is called after"
 ! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 10/27/2007 22:48'!
isSessionHelper

	^ true! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 03:00'!
performRequest: aRequest with: aBlock

	^ aBlock! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/8/2007 05:22'!
postProcessRequest: aRequest returned: aResponse

	"This gets called AFTER Kom has sent the response to the browser"! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 05:29'!
responseForRequest: aRequest wrap: aBlock

	^ aBlock! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/19/2008 03:58'!
setUp: helpers

	helpers session
 ! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/17/2007 20:46'!
species

	^ WASessionHelper! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 20:00'!
tearDown! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 11/16/2007 19:59'!
unregistered
	"called at session expiry"
	self tearDown! !

!WASessionHelper methodsFor: 'as yet unclassified' stamp: 'kph 12/9/2007 01:51'!
updateRoot: aHtmlRoot

	"signals the start of rendering"! !

Object subclass: #WAUSStates
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Useful-Data'!

!WAUSStates class methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 10:22'!
value

 ^ { 

'AL' -> 'Alabama'.
'AK'->'Alaska'.
'AZ'->'Arizona'. 
'AR'->'Arkansas'. 
'CA'->'California'. 
'CO'->'Colorado'. 
'CT'->'Connecticut'. 
'DE'->'Delaware'. 
'DC'->'District Of Columbia'. 
'FL'->'Florida'. 
'GA'->'Georgia'. 
'HI'->'Hawaii'. 
'ID'->'Idaho'. 
'IL'->'Illinois'. 
'IN'->'Indiana'. 
'IA'->'Iowa'. 
'KS'->'Kansas'. 
'KY'->'Kentucky'. 
'LA'->'Louisiana'. 
'ME'->'Maine'. 
'MD'->'Maryland'. 
'MA'->'Massachusetts'. 
'MI'->'Michigan'. 
'MN'->'Minnesota'. 
'MS'->'Mississippi'. 
'MO'->'Missouri'. 
'MT'->'Montana'.
'NE'->'Nebraska'.
'NV'->'Nevada'.
'NH'->'New Hampshire'.
'NJ'->'New Jersey'.
'NM'->'New Mexico'.
'NY'->'New York'.
'NC'->'North Carolina'.
'ND'->'North Dakota'.
'OH'->'Ohio'. 
'OK'->'Oklahoma'. 
'OR'->'Oregon'. 
'PA'->'Pennsylvania'. 
'RI'->'Rhode Island'. 
'SC'->'South Carolina'. 
'SD'->'South Dakota'.
'TN'->'Tennessee'. 
'TX'->'Texas'. 
'UT'->'Utah'. 
'VT'->'Vermont'. 
'VA'->'Virginia'. 
'WA'->'Washington'. 
'WV'->'West Virginia'. 
'WI'->'Wisconsin'. 
'WY'->'Wyoming'
}! !

Object subclass: #WAUsefulJS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Libraries'!

!WAUsefulJS commentStamp: 'kph 1/8/2008 04:08' prior: 0!
Snippets of js, to include in your application's file library
!

PackageInfo subclass: #JSPackageInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Info'!

!JSPackageInfo class methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:34'!
initialize
	[self new register] on: MessageNotUnderstood do: ["must be an old version of PackageInfo"] ! !

!JSPackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:16'!
additionalFiles

	^#()! !

!JSPackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:16'!
changesText

	^ 'version 1:
  Initial public release.'! !

!JSPackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 7/19/2007 11:33'!
packageName

	^ 'Seaside28Jetsam'! !

!JSPackageInfo methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 17:55'!
readmeText

	^'Base package extensions that other Jetsam, or other Seaside packages might need

	note: the method category prefix for SeasideJetsam is *js- or *js-override
	this still leaves some room for categorizing the method properly

ext 01: WAConfiguration-hasPreferenceGroup;
ext 02: WACachedDocument-clear to ensure next access the document is re-read from disk.
ext 03: WATagBrush-idNotNil: convenience method for setting ids.
ext 04: WAImageTag-fileName: restore old api, so that it can be used even though deprecated.
ext 05: WAHtmlCanvas-heading:level: restore old api, so that it can be used even though deprecated.
ext 06: WASession-download: contents mimeType: mimeType filename: fileName
	    Enables an anchor to respond with the file content to be downloaded.
ext 07: WADocumentHandler-mimeDocument/response
	   Enables documentClasses to signal respond with doNotCache by implementing #notCached
ext 08: WABatchedList-totalSize accessor
ext 09: WANotCachedDocument - document that doesnt want to be cached in memory
ext 10: WALibrary names and hence urls are not tied to the class name,  #libraryName can be specified.
ext 11: WAFileHandler-responseAt:ifAbsent:/libraryAt:ifAbsent:
	    This resolution process enables the libarary resolved by the url to decide who serves the document. 
		(the default behaviour is hardwired such that that library class itself has to serve the content).
ext 12: WAStandardFilesPlus and WAStandardFilesPlusTest
		- see class comment for details.
		- override seaside defaults in your project, and also serve from DISK if you wish.
		
ext 13: WAKom class>>startOn:servingFilesFrom:
		- see method comment for details
ext 14: WADispatcherControlPanel - provides common features for a UI spawned from a WADispatcherPlugIn 
		- For example usage see: "Magma seaside" or "Pier-PersistencyManager"
ext 15: WAKeepSessionAliveDecoration and WAJetsamConfiguration #keepSessionAlive	
ext 16: ShoreHelperDecoration and WAJetsamConfiguration #enableShoreHelper
ext 17: String-#withoutTrailingSlash	 
ext 18 WACss
ext 19 WASession-forApp:during: 
	this gets you command line access to the session outside of browser
	with the configuration of the named application
ext 20 Helper
ext 21 UsefulData - WACountries WAUSStates
ext 22 postProcessRequest: aRequest returned: aResponse
ext 23 #debugInternalErrors preference	  
ext 24 onlLoadScripts can be a block evaluated at write time	  
ext 25 NiftyCorners
'! !

!WAImageTag methodsFor: '*seaside28jetsam-accessing' stamp: 'kph 7/11/2007 22:22'!
fileName: aFileName
	self deprecatedApi.
	self document: (WACachedDocument fileName: aFileName)! !

!WARegistry methodsFor: '*seaside28jetsam-override' stamp: 'kph 10/18/2007 03:29'!
clearHandlers
	| handlers |
	self mutex critical: [
		handlers := handlersByKey.
		handlersByKey := SeasidePlatformSupport reducedConflictDictionary new.
		keysByHandler := SeasidePlatformSupport reducedConflictDictionary new ].
	handlers ifNotNil: [
		[ handlers do: [ :each | each unregistered ] ]
			fork ].
		
	^ handlers ifNil: [ 0 ] ifNotNil: [ handlers size ]! !

!WARegistry methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 10/31/2007 04:11'!
handlersByKey

	^ handlersByKey! !

!WARegistry methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/8/2007 05:14'!
postProcessRequest: aRequest returned: aResponse

	self subclassResponsibility! !

!WAConfiguration methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 12/9/2007 04:37'!
commentForAttribute: anAttribute  
	| selector |
 
	self inheritedValueAndSourceAt: anAttribute key do: [ :value :source |
		selector := ('comment', anAttribute key capitalized, ':config:') asSymbol.
		
		(source respondsTo: selector) ifTrue: [ ^ source perform: selector with: (self valueForAttribute: anAttribute) with: self ]
	].
	
	^ nil! !

!WAConfiguration methodsFor: '*seaside28jetsam-helpers' stamp: 'kph 7/19/2007 11:28'!
hasGroupNamed: aSymbol
	^ self allAttributes anySatisfy: [:ea | ea group = aSymbol]! !

WAConfigurationEditor subclass: #FLHandlerEditor
	instanceVariableNames: 'link'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-FilesystemLink'!

!FLHandlerEditor methodsFor: 'accessing' stamp: 'pmm 7/19/2007 18:21'!
link
	^link! !

!FLHandlerEditor methodsFor: 'accessing' stamp: 'pmm 7/19/2007 18:21'!
link: anObject
	link := anObject! !

!FLHandlerEditor methodsFor: 'rendering' stamp: 'pmm 7/19/2007 18:34'!
renderFormOn: html
	html heading level1; with: 'Configuration'.
	html table: [
		html tableRow: [
			html tableHeading: 'Root Directory'.
			html tableData: [
				html textInput
					on: #root of: self link ] ] ]! !

!WAConfigurationEditor methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 12/9/2007 04:37'!
renderAttribute: anAttribute on: html
	html tableRow: [
		html tableData: (self labelForSelector: anAttribute key).
		html tableData: [
			(configuration valueForAttribute: anAttribute)
				ifNil: [ self renderUnspecifiedAttribute: anAttribute on: html ]
				ifNotNil: [
					(configuration hasLocalValueForAttribute: anAttribute)
						ifTrue: [ self renderOverridenAttribute: anAttribute on: html ]
						ifFalse: [ self renderInheritedAttribute: anAttribute on: html ] ] ].
		self renderInheritanceForAttribute: anAttribute on: html ].
	(configuration commentForAttribute: anAttribute)
		ifNotNilDo: [ :comment |
						html tableRow:
							   [ html tableData: [].
								html tableData colSpan: 3; with: [ html small: [ html html: comment ] ] ]
		]
	! !

WAFileLibrary subclass: #BlueprintLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Blueprint'!

!BlueprintLibrary methodsFor: 'blueprint' stamp: 'kph 5/26/2008 10:40'!
fileSelectors
 
	^  (((self class withAllSuperclasses upTo: WAFileLibrary) 
			gather:[:aClass | aClass selectors])
				select: [ :each | self isFileSelector: each ])  
										difference: self nonFileSelectors   ! !

!BlueprintLibrary methodsFor: 'blueprint' stamp: 'kph 5/26/2008 10:39'!
ieCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* ie.css */
body {text-align:center;}
.container {text-align:left;}
* html .column {overflow-x:hidden;}
* html legend {margin:-18px -8px 16px 0;padding:0;}
ol {margin-left:2em;}
sup {vertical-align:text-top;}
sub {vertical-align:text-bottom;}
html>body p code {*white-space:normal;}
hr {margin:-8px auto 11px;}'! !

!BlueprintLibrary methodsFor: 'blueprint' stamp: 'kph 5/26/2008 10:39'!
printCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* print.css */
body {line-height:1.5;font-family:"Helvetica Neue", Helvetica, Arial, sans-serif;color:#000;background:none;font-size:10pt;}
.container {background:none;}
hr {background:#ccc;color:#ccc;width:100%;height:2px;margin:2em 0;padding:0;border:none;}
hr.space {background:#fff;color:#fff;}
h1, h2, h3, h4, h5, h6 {font-family:"Helvetica Neue", Arial, "Lucida Grande", sans-serif;}
code {font:.9em "Courier New", Monaco, Courier, monospace;}
img {float:left;margin:1.5em 1.5em 1.5em 0;}
a img {border:none;}
p img.top {margin-top:0;}
blockquote {margin:1.5em;padding:1em;font-style:italic;font-size:.9em;}
.small {font-size:.9em;}
.large {font-size:1.1em;}
.quiet {color:#999;}
.hide {display:none;}
a:link, a:visited {background:transparent;font-weight:700;text-decoration:underline;}
a:link:after, a:visited:after {content:" (" attr(href) ") ";font-size:90%;}'! !

!BlueprintLibrary methodsFor: 'blueprint' stamp: 'kph 5/26/2008 10:39'!
screenCss
	^ '/* -----------------------------------------------------------------------

   Blueprint CSS Framework 0.7.1
   http://blueprintcss.googlecode.com

   * Copyright (c) 2007-2008. See LICENSE for more info.
   * See README for instructions on how to use Blueprint.
   * For credits and origins, see AUTHORS.
   * This is a compressed file. See the sources in the ''src'' directory.

----------------------------------------------------------------------- */

/* reset.css */
html, body, div, span, object, iframe, h1, h2, h3, h4, h5, h6, p, blockquote, pre, a, abbr, acronym, address, code, del, dfn, em, img, q, dl, dt, dd, ol, ul, li, fieldset, form, label, legend, table, caption, tbody, tfoot, thead, tr, th, td {margin:0;padding:0;border:0;font-weight:inherit;font-style:inherit;font-size:100%;font-family:inherit;vertical-align:baseline;}
body {line-height:1.5;}
table {border-collapse:separate;border-spacing:0;}
caption, th, td {text-align:left;font-weight:normal;}
table, td, th {vertical-align:middle;}
blockquote:before, blockquote:after, q:before, q:after {content:"";}
blockquote, q {quotes:"" "";}
a img {border:none;}

/* typography.css */
body {font-size:75%;color:#222;background:#fff;font-family:"Helvetica Neue", Helvetica, Arial, sans-serif;}
h1, h2, h3, h4, h5, h6 {font-weight:normal;color:#111;}
h1 {font-size:3em;line-height:1;margin-bottom:0.5em;}
h2 {font-size:2em;margin-bottom:0.75em;}
h3 {font-size:1.5em;line-height:1;margin-bottom:1em;}
h4 {font-size:1.2em;line-height:1.25;margin-bottom:1.25em;height:1.25em;}
h5 {font-size:1em;font-weight:bold;margin-bottom:1.5em;}
h6 {font-size:1em;font-weight:bold;}
h1 img, h2 img, h3 img, h4 img, h5 img, h6 img {margin:0;}
p {margin:0 0 1.5em;}
p img {float:left;margin:1.5em 1.5em 1.5em 0;padding:0;}
p img.right {float:right;margin:1.5em 0 1.5em 1.5em;}
a:focus, a:hover {color:#000;}
a {color:#009;text-decoration:underline;}
blockquote {margin:1.5em;color:#666;font-style:italic;}
strong {font-weight:bold;}
em, dfn {font-style:italic;}
dfn {font-weight:bold;}
sup, sub {line-height:0;}
abbr, acronym {border-bottom:1px dotted #666;}
address {margin:0 0 1.5em;font-style:italic;}
del {color:#666;}
pre, code {margin:1.5em 0;white-space:pre;}
pre, code, tt {font:1em ''andale mono'', ''lucida console'', monospace;line-height:1.5;}
li ul, li ol {margin:0 1.5em;}
ul, ol {margin:0 1.5em 1.5em 1.5em;}
ul {list-style-type:disc;}
ol {list-style-type:decimal;}
dl {margin:0 0 1.5em 0;}
dl dt {font-weight:bold;}
dd {margin-left:1.5em;}
table {margin-bottom:1.4em;width:100%;}
th {font-weight:bold;background:#C3D9FF;}
th, td {padding:4px 10px 4px 5px;}
tr.even td {background:#E5ECF9;}
tfoot {font-style:italic;}
caption {background:#eee;}
.small {font-size:.8em;margin-bottom:1.875em;line-height:1.875em;}
.large {font-size:1.2em;line-height:2.5em;margin-bottom:1.25em;}
.hide {display:none;}
.quiet {color:#666;}
.loud {color:#000;}
.highlight {background:#ff0;}
.added {background:#060;color:#fff;}
.removed {background:#900;color:#fff;}
.first {margin-left:0;padding-left:0;}
.last {margin-right:0;padding-right:0;}
.top {margin-top:0;padding-top:0;}
.bottom {margin-bottom:0;padding-bottom:0;}

/* grid.css */
.container {width:950px;margin:0 auto;}
.showgrid {background:url(src/grid.png);}
body {margin:1.5em 0;}
div.span-1, div.span-2, div.span-3, div.span-4, div.span-5, div.span-6, div.span-7, div.span-8, div.span-9, div.span-10, div.span-11, div.span-12, div.span-13, div.span-14, div.span-15, div.span-16, div.span-17, div.span-18, div.span-19, div.span-20, div.span-21, div.span-22, div.span-23, div.span-24 {float:left;margin-right:10px;}
div.last {margin-right:0;}
.span-1 {width:30px;}
.span-2 {width:70px;}
.span-3 {width:110px;}
.span-4 {width:150px;}
.span-5 {width:190px;}
.span-6 {width:230px;}
.span-7 {width:270px;}
.span-8 {width:310px;}
.span-9 {width:350px;}
.span-10 {width:390px;}
.span-11 {width:430px;}
.span-12 {width:470px;}
.span-13 {width:510px;}
.span-14 {width:550px;}
.span-15 {width:590px;}
.span-16 {width:630px;}
.span-17 {width:670px;}
.span-18 {width:710px;}
.span-19 {width:750px;}
.span-20 {width:790px;}
.span-21 {width:830px;}
.span-22 {width:870px;}
.span-23 {width:910px;}
.span-24, div.span-24 {width:950px;margin:0;}
.append-1 {padding-right:40px;}
.append-2 {padding-right:80px;}
.append-3 {padding-right:120px;}
.append-4 {padding-right:160px;}
.append-5 {padding-right:200px;}
.append-6 {padding-right:240px;}
.append-7 {padding-right:280px;}
.append-8 {padding-right:320px;}
.append-9 {padding-right:360px;}
.append-10 {padding-right:400px;}
.append-11 {padding-right:440px;}
.append-12 {padding-right:480px;}
.append-13 {padding-right:520px;}
.append-14 {padding-right:560px;}
.append-15 {padding-right:600px;}
.append-16 {padding-right:640px;}
.append-17 {padding-right:680px;}
.append-18 {padding-right:720px;}
.append-19 {padding-right:760px;}
.append-20 {padding-right:800px;}
.append-21 {padding-right:840px;}
.append-22 {padding-right:880px;}
.append-23 {padding-right:920px;}
.prepend-1 {padding-left:40px;}
.prepend-2 {padding-left:80px;}
.prepend-3 {padding-left:120px;}
.prepend-4 {padding-left:160px;}
.prepend-5 {padding-left:200px;}
.prepend-6 {padding-left:240px;}
.prepend-7 {padding-left:280px;}
.prepend-8 {padding-left:320px;}
.prepend-9 {padding-left:360px;}
.prepend-10 {padding-left:400px;}
.prepend-11 {padding-left:440px;}
.prepend-12 {padding-left:480px;}
.prepend-13 {padding-left:520px;}
.prepend-14 {padding-left:560px;}
.prepend-15 {padding-left:600px;}
.prepend-16 {padding-left:640px;}
.prepend-17 {padding-left:680px;}
.prepend-18 {padding-left:720px;}
.prepend-19 {padding-left:760px;}
.prepend-20 {padding-left:800px;}
.prepend-21 {padding-left:840px;}
.prepend-22 {padding-left:880px;}
.prepend-23 {padding-left:920px;}
div.border {padding-right:4px;margin-right:5px;border-right:1px solid #eee;}
div.colborder {padding-right:24px;margin-right:25px;border-right:1px solid #eee;}
.pull-1 {margin-left:-40px;}
.pull-2 {margin-left:-80px;}
.pull-3 {margin-left:-120px;}
.pull-4 {margin-left:-160px;}
.pull-5 {margin-left:-200px;}
.pull-6 {margin-left:-240px;}
.pull-7 {margin-left:-280px;}
.pull-8 {margin-left:-320px;}
.pull-9 {margin-left:-360px;}
.pull-10 {margin-left:-400px;}
.pull-11 {margin-left:-440px;}
.pull-12 {margin-left:-480px;}
.pull-13 {margin-left:-520px;}
.pull-14 {margin-left:-560px;}
.pull-15 {margin-left:-600px;}
.pull-16 {margin-left:-640px;}
.pull-17 {margin-left:-680px;}
.pull-18 {margin-left:-720px;}
.pull-19 {margin-left:-760px;}
.pull-20 {margin-left:-800px;}
.pull-21 {margin-left:-840px;}
.pull-22 {margin-left:-880px;}
.pull-23 {margin-left:-920px;}
.pull-24 {margin-left:-960px;}
.pull-1, .pull-2, .pull-3, .pull-4, .pull-5, .pull-6, .pull-7, .pull-8, .pull-9, .pull-10, .pull-11, .pull-12, .pull-13, .pull-14, .pull-15, .pull-16, .pull-17, .pull-18, .pull-19, .pull-20, .pull-21, .pull-22, .pull-23, .pull-24 {float:left;position:relative;}
.push-1 {margin:0 -40px 1.5em 40px;}
.push-2 {margin:0 -80px 1.5em 80px;}
.push-3 {margin:0 -120px 1.5em 120px;}
.push-4 {margin:0 -160px 1.5em 160px;}
.push-5 {margin:0 -200px 1.5em 200px;}
.push-6 {margin:0 -240px 1.5em 240px;}
.push-7 {margin:0 -280px 1.5em 280px;}
.push-8 {margin:0 -320px 1.5em 320px;}
.push-9 {margin:0 -360px 1.5em 360px;}
.push-10 {margin:0 -400px 1.5em 400px;}
.push-11 {margin:0 -440px 1.5em 440px;}
.push-12 {margin:0 -480px 1.5em 480px;}
.push-13 {margin:0 -520px 1.5em 520px;}
.push-14 {margin:0 -560px 1.5em 560px;}
.push-15 {margin:0 -600px 1.5em 600px;}
.push-16 {margin:0 -640px 1.5em 640px;}
.push-17 {margin:0 -680px 1.5em 680px;}
.push-18 {margin:0 -720px 1.5em 720px;}
.push-19 {margin:0 -760px 1.5em 760px;}
.push-20 {margin:0 -800px 1.5em 800px;}
.push-21 {margin:0 -840px 1.5em 840px;}
.push-22 {margin:0 -880px 1.5em 880px;}
.push-23 {margin:0 -920px 1.5em 920px;}
.push-24 {margin:0 -960px 1.5em 960px;}
.push-1, .push-2, .push-3, .push-4, .push-5, .push-6, .push-7, .push-8, .push-9, .push-10, .push-11, .push-12, .push-13, .push-14, .push-15, .push-16, .push-17, .push-18, .push-19, .push-20, .push-21, .push-22, .push-23, .push-24 {float:right;position:relative;}
.box {padding:1.5em;margin-bottom:1.5em;background:#E5ECF9;}
hr {background:#ddd;color:#ddd;clear:both;float:none;width:100%;height:.1em;margin:0 0 1.45em;border:none;}
hr.space {background:#fff;color:#fff;}
.clearfix:after, .container:after {content:".";display:block;height:0;clear:both;visibility:hidden;}
.clearfix, .container {display:inline-block;}
* html .clearfix, * html .container {height:1%;}
.clearfix, .container {display:block;}
.clear {clear:both;}

/* forms.css */
label {font-weight:bold;}
fieldset {padding:1.4em;margin:0 0 1.5em 0;border:1px solid #ccc;}
legend {font-weight:bold;font-size:1.2em;}
input.text, input.title, textarea, select {margin:0.5em 0;border:1px solid #bbb;}
input.text:focus, input.title:focus, textarea:focus, select:focus {border:1px solid #666;}
input.text, input.title {width:300px;padding:5px;}
input.title {font-size:1.5em;}
textarea {width:390px;height:250px;padding:5px;}
.error, .notice, .success {padding:.8em;margin-bottom:1em;border:2px solid #ddd;}
.error {background:#FBE3E4;color:#8a1f11;border-color:#FBC2C4;}
.notice {background:#FFF6BF;color:#514721;border-color:#FFD324;}
.success {background:#E6EFC2;color:#264409;border-color:#C6D880;}
.error a {color:#8a1f11;}
.notice a {color:#514721;}
.success a {color:#264409;}'! !

!BlueprintLibrary methodsFor: 'processing' stamp: 'kph 5/26/2008 10:40'!
updateRoot: aHtmlRoot
	super updateRoot: aHtmlRoot.
	aHtmlRoot stylesheet
		addScreen;
		addProjection;
		url: (self urlOf: #screenCss).
	aHtmlRoot stylesheet
		addPrint;
		url: (self urlOf: #printCss).
	aHtmlRoot if ie do: [
		aHtmlRoot stylesheet
			addScreen;
			addProjection;
			url: (self urlOf: #ieCss) ].
 ! !

WAFileLibrary subclass: #NiftyCornersCube
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-NiftyCorners'!

!NiftyCornersCube commentStamp: 'kph 4/21/2008 16:15' prior: 0!
Usage: Add the NiftyCornersCube to your application's libraries.

To use nifty, add the following to your application's css library, or to components.

updateRoot: htmlRoot

htmlRoot context session addLoadScript:  

'/*nifty corners layout*/
Nifty("div#menu a","small transparent top");
Nifty("ul#intro li","same-height");
Nifty("div.date");
Nifty("div#content,div#side","same-height");
Nifty("div.comments div");
Nifty("div#footer");
Nifty("div#container","bottom")

License

/* Nifty Corners Cube - rounded corners with CSS and Javascript
Copyright 2006 Alessandro Fulciniti (a.fulciniti@html.it)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


'!

!NiftyCornersCube methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 15:54'!
modifications
"
The AddCss() function has been removed from the original script.


"! !

!NiftyCornersCube methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 03:59'!
niftycornersCss

^ '
/*Nifty Corners Cube CSS by Alessandro Fulciniti
The following classes are added dinamically by javascript,
and their use should be avoided in the markup */

b.niftycorners,b.niftyfill{display:block}
b.niftycorners *{display:block;height: 1px;line-height:1px;font-size: 1px;
    overflow:hidden;border-style:solid;border-width: 0 1px}
/*normal*/
b.r1{margin: 0 3px;border-width: 0 2px}
b.r2{margin: 0 2px}
b.r3{margin: 0 1px}
b.r4{height: 2px}
b.rb1{margin: 0 8px;border-width:0 2px}
b.rb2{margin: 0 6px;border-width:0 2px}
b.rb3{margin: 0 5px}
b.rb4{margin: 0 4px}
b.rb5{margin: 0 3px}
b.rb6{margin: 0 2px}
b.rb7{margin: 0 1px;height:2px}
b.rb8{margin: 0;height:2px}
b.rs1{margin: 0 1px}
/*transparent inside*/
b.t1{border-width: 0 5px}
b.t2{border-width: 0 3px}
b.t3{border-width: 0 2px}
b.t4{height: 2px}
b.tb1{border-width: 0 10px}
b.tb2{border-width: 0 8px}
b.tb3{border-width: 0 6px}
b.tb4{border-width: 0 5px}
b.tb5{border-width: 0 4px}
b.tb6{border-width: 0 3px}
b.tb7{border-width: 0 2px;height:2px}
b.tb8{border-width: 0 1px;height:2px}
b.ts1{border-width: 0 2px}'! !

!NiftyCornersCube methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 16:01'!
niftycornersJs

^'
/* Nifty Corners Cube - rounded corners with CSS and Javascript
Copyright 2006 Alessandro Fulciniti (a.fulciniti@html.it)

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

var niftyOk=(document.getElementById && document.createElement && Array.prototype.push);
var niftyCss=false;

String.prototype.find=function(what){
return(this.indexOf(what)>=0 ? true : false);
}

var oldonload=window.onload;
if(typeof(NiftyLoad)!!="function") NiftyLoad=function(){};
if(typeof(oldonload)=="function")
    window.onload=function(){oldonload();NiftyLoad()};
else window.onload=function(){ NiftyLoad()};

function Nifty(selector,options){
if(niftyOk==false) return;

var i,v=selector.split(","),h=0;
if(options==null) options="";
if(options.find("fixed-height"))
    h=getElementsBySelector(v[0])[0].offsetHeight;
for(i=0;i<v.length;i++)
    Rounded(v[i],options);
if(options.find("height")) SameHeight(selector,h);
}

function Rounded(selector,options){
var i,top="",bottom="",v=new Array();
if(options!!=""){
    options=options.replace("left","tl bl");
    options=options.replace("right","tr br");
    options=options.replace("top","tr tl");
    options=options.replace("bottom","br bl");
    options=options.replace("transparent","alias");
    if(options.find("tl")){
        top="both";
        if(!!options.find("tr")) top="left";
        }
    else if(options.find("tr")) top="right";
    if(options.find("bl")){
        bottom="both";
        if(!!options.find("br")) bottom="left";
        }
    else if(options.find("br")) bottom="right";
    }
if(top=="" && bottom=="" && !!options.find("none")){top="both";bottom="both";}
v=getElementsBySelector(selector);
for(i=0;i<v.length;i++){
    FixIE(v[i]);
    if(top!!="") AddTop(v[i],top,options);
    if(bottom!!="") AddBottom(v[i],bottom,options);
    }
}

function AddTop(el,side,options){
var d=CreateEl("b"),lim=4,border="",p,i,btype="r",bk,color;
d.style.marginLeft="-"+getPadding(el,"Left")+"px";
d.style.marginRight="-"+getPadding(el,"Right")+"px";
if(options.find("alias") || (color=getBk(el))=="transparent"){
    color="transparent";bk="transparent"; border=getParentBk(el);btype="t";
    }
else{
    bk=getParentBk(el); border=Mix(color,bk);
    }
d.style.background=bk;
d.className="niftycorners";
p=getPadding(el,"Top");
if(options.find("small")){
    d.style.marginBottom=(p-2)+"px";
    btype+="s"; lim=2;
    }
else if(options.find("big")){
    d.style.marginBottom=(p-10)+"px";
    btype+="b"; lim=8;
    }
else d.style.marginBottom=(p-5)+"px";
for(i=1;i<=lim;i++)
    d.appendChild(CreateStrip(i,side,color,border,btype));
el.style.paddingTop="0";
el.insertBefore(d,el.firstChild);
}

function AddBottom(el,side,options){
var d=CreateEl("b"),lim=4,border="",p,i,btype="r",bk,color;
d.style.marginLeft="-"+getPadding(el,"Left")+"px";
d.style.marginRight="-"+getPadding(el,"Right")+"px";
if(options.find("alias") || (color=getBk(el))=="transparent"){
    color="transparent";bk="transparent"; border=getParentBk(el);btype="t";
    }
else{
    bk=getParentBk(el); border=Mix(color,bk);
    }
d.style.background=bk;
d.className="niftycorners";
p=getPadding(el,"Bottom");
if(options.find("small")){
    d.style.marginTop=(p-2)+"px";
    btype+="s"; lim=2;
    }
else if(options.find("big")){
    d.style.marginTop=(p-10)+"px";
    btype+="b"; lim=8;
    }
else d.style.marginTop=(p-5)+"px";
for(i=lim;i>0;i--)
    d.appendChild(CreateStrip(i,side,color,border,btype));
el.style.paddingBottom=0;
el.appendChild(d);
}

function CreateStrip(index,side,color,border,btype){
var x=CreateEl("b");
x.className=btype+index;
x.style.backgroundColor=color;
x.style.borderColor=border;
if(side=="left"){
    x.style.borderRightWidth="0";
    x.style.marginRight="0";
    }
else if(side=="right"){
    x.style.borderLeftWidth="0";
    x.style.marginLeft="0";
    }
return(x);
}

function CreateEl(x){
return(document.createElement(x));
}

function FixIE(el){
if(el.currentStyle!!=null && el.currentStyle.hasLayout!!=null && el.currentStyle.hasLayout==false)
    el.style.display="inline-block";
}

function SameHeight(selector,maxh){
var i,v=selector.split(","),t,j,els=[],gap;
for(i=0;i<v.length;i++){
    t=getElementsBySelector(v[i]);
    els=els.concat(t);
    }
for(i=0;i<els.length;i++){
    if(els[i].offsetHeight>maxh) maxh=els[i].offsetHeight;
    els[i].style.height="auto";
    }
for(i=0;i<els.length;i++){
    gap=maxh-els[i].offsetHeight;
    if(gap>0){
        t=CreateEl("b");t.className="niftyfill";t.style.height=gap+"px";
        nc=els[i].lastChild;
        if(nc.className=="niftycorners")
            els[i].insertBefore(t,nc);
        else els[i].appendChild(t);
        }
    }
}

function getElementsBySelector(selector){
var i,j,selid="",selclass="",tag=selector,tag2="",v2,k,f,a,s=[],objlist=[],c;
if(selector.find("#")){ //id selector like "tag#id"
    if(selector.find(" ")){  //descendant selector like "tag#id tag"
        s=selector.split(" ");
        var fs=s[0].split("#");
        if(fs.length==1) return(objlist);
        f=document.getElementById(fs[1]);
        if(f){
            v=f.getElementsByTagName(s[1]);
            for(i=0;i<v.length;i++) objlist.push(v[i]);
            }
        return(objlist);
        }
    else{
        s=selector.split("#");
        tag=s[0];
        selid=s[1];
        if(selid!!=""){
            f=document.getElementById(selid);
            if(f) objlist.push(f);
            return(objlist);
            }
        }
    }
if(selector.find(".")){      //class selector like "tag.class"
    s=selector.split(".");
    tag=s[0];
    selclass=s[1];
    if(selclass.find(" ")){   //descendant selector like tag1.classname tag2
        s=selclass.split(" ");
        selclass=s[0];
        tag2=s[1];
        }
    }
var v=document.getElementsByTagName(tag);  // tag selector like "tag"
if(selclass==""){
    for(i=0;i<v.length;i++) objlist.push(v[i]);
    return(objlist);
    }
for(i=0;i<v.length;i++){
    c=v[i].className.split(" ");
    for(j=0;j<c.length;j++){
        if(c[j]==selclass){
            if(tag2=="") objlist.push(v[i]);
            else{
                v2=v[i].getElementsByTagName(tag2);
                for(k=0;k<v2.length;k++) objlist.push(v2[k]);
                }
            }
        }
    }
return(objlist);
}

function getParentBk(x){
var el=x.parentNode,c;
while(el.tagName.toUpperCase()!!="HTML" && (c=getBk(el))=="transparent")
    el=el.parentNode;
if(c=="transparent") c="#FFFFFF";
return(c);
}

function getBk(x){
var c=getStyleProp(x,"backgroundColor");
if(c==null || c=="transparent" || c.find("rgba(0, 0, 0, 0)"))
    return("transparent");
if(c.find("rgb")) c=rgb2hex(c);
return(c);
}

function getPadding(x,side){
var p=getStyleProp(x,"padding"+side);
if(p==null || !!p.find("px")) return(0);
return(parseInt(p));
}

function getStyleProp(x,prop){
if(x.currentStyle)
    return(x.currentStyle[prop]);
if(document.defaultView.getComputedStyle)
    return(document.defaultView.getComputedStyle(x,"")[prop]);
return(null);
}

function rgb2hex(value){
var hex="",v,h,i;
var regexp=/([0-9]+)[, ]+([0-9]+)[, ]+([0-9]+)/;
var h=regexp.exec(value);
for(i=1;i<4;i++){
    v=parseInt(h[i]).toString(16);
    if(v.length==1) hex+="0"+v;
    else hex+=v;
    }
return("#"+hex);
}

function Mix(c1,c2){
var i,step1,step2,x,y,r=new Array(3);
if(c1.length==4)step1=1;
else step1=2;
if(c2.length==4) step2=1;
else step2=2;
for(i=0;i<3;i++){
    x=parseInt(c1.substr(1+step1*i,step1),16);
    if(step1==1) x=16*x+x;
    y=parseInt(c2.substr(1+step2*i,step2),16);
    if(step2==1) y=16*y+y;
    r[i]=Math.floor((x*50+y*50)/100);
    r[i]=r[i].toString(16);
    if(r[i].length==1) r[i]="0"+r[i];
    }
return("#"+r[0]+r[1]+r[2]);
}
'! !

!NiftyCornersCube methodsFor: 'as yet unclassified' stamp: 'kph 4/21/2008 04:04'!
selectorsToInclude

^ #( #niftycornersCss niftycornersJs )! !

WAFileLibrary subclass: #Supersleight
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Supersleight'!

!Supersleight commentStamp: 'kph 5/26/2008 10:55' prior: 0!
http://24ways.org/2007/supersleight-transparent-png-in-ie6!

!Supersleight methodsFor: 'as yet unclassified' stamp: 'kph 5/23/2008 21:30'!
modifications
"
Removed addLoadEvent()
Use the seaside onLoad idiom
"! !

!Supersleight methodsFor: 'as yet unclassified' stamp: 'kph 5/23/2008 21:40'!
selectorsToInclude

^ #( )! !

!Supersleight methodsFor: 'uploaded' stamp: 'kph 5/23/2008 21:36'!
supersleightJs
	^ 'var supersleight	= function() {
	
 	var applyPositioning = true;
	
	// Path to a transparent GIF image
	var shim			= ''x.gif'';
	
	// RegExp to match above GIF image name
	var shim_pattern	= /x\.gif$/i;
	
	var fnLoadPngs = function(root) { 
		if (root) {
			root = document.getElementById(root);
		}else{
			root = document;
		}
		for (var i = root.all.length - 1, obj = null; (obj = root.all[i]); i--) {
			// background pngs
			if (obj.currentStyle.backgroundImage.match(/\.png/i) !!== null) {
				bg_fnFixPng(obj);
			}
			// image elements
			if (obj.tagName==''IMG'' && obj.src.match(/\.png$/i) !!== null){
				el_fnFixPng(obj);
			}
			// apply position to ''active'' elements
			if (applyPositioning && (obj.tagName==''A'' || obj.tagName==''INPUT'') && obj.style.position === ''''){
				obj.style.position = ''relative'';
			}
		}
	};

	var bg_fnFixPng = function(obj) {
		var mode = ''scale'';
		var bg	= obj.currentStyle.backgroundImage;
		var src = bg.substring(5,bg.length-2);
		if (obj.currentStyle.backgroundRepeat == ''no-repeat'') {
			mode = ''crop'';
		}
		obj.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src=''" + src + "'', sizingMethod=''" + mode + "'')";
		obj.style.backgroundImage = ''url(''+shim+'')'';
	};

	var el_fnFixPng = function(img) {
		var src = img.src;
		img.style.width = img.width + "px";
		img.style.height = img.height + "px";
		img.style.filter = "progid:DXImageTransform.Microsoft.AlphaImageLoader(src=''" + src + "'', sizingMethod=''scale'')";
		img.src = shim;
	};
	
 
	
	return {
 	 
		run: function(r) {
			fnLoadPngs(r);
		}
	};
}();
'
! !

!Supersleight methodsFor: 'uploaded' stamp: 'kph 5/23/2008 22:23'!
updateRoot: htmlRoot
				 

	htmlRoot if ie6; do: [ 

	 		htmlRoot script
				defer;
				url: (self urlOf: #supersleightJs).

	].

	htmlRoot context session addLoadScript: 'if (typeof(supersleight) !!= "undefined") { supersleight.run(null) }'.
! !

!Supersleight methodsFor: 'uploaded' stamp: ''!
xGif
	| cache |
	cache := #(nil) beMutable.
	(cache at: 1) isNil ifTrue: [
		cache at: 1 put: #(71 73 70 56 57 97 1 0 1 0 145 0 0 0 0 0 255 255 255 250 247 225 0 0 0 33 249 4 1 0 0 2 0 44 0 0 0 0 1 0 1 0 0 2 2 84 1 0 59) asByteArray ].
	^ cache at: 1! !

WAFileLibrary subclass: #WAAbsoluteFudgeJS
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-AbsoluteFudgeIE6'!

!WAAbsoluteFudgeJS methodsFor: 'as yet unclassified' stamp: 'kph 4/4/2008 00:47'!
absoluteFudgeJs

^ '
/*****************************************************************

  AbsoluteFudge module
  ====================

  Example usage. set the onload handler of the document to point to:
  
function onLoad() {
  if (AbsoluteFudge !!= undefined) {
    AbsoluteFudge.apply(document.getElementsByTagName("body")[0], true, true)
  }
  // other loading stuff...
}

  The apply() method walks the entire document. If you set the second and
  third parameters to true. The second parameter instructs apply() to walk the
  entire document looking for absolutely positioned elements. The third
  tells it to carry on through non absolutely positioned elements. If both
  are true, the entire document is traversed. If both are false it will just
  apply the fudge to that single element. If true,false then recursion
  is limited to absolutely positioned elements. searching stops once
  non-absolute elements are found.
  
  If you are generating html elements dynamically (eg Ajax programming) then
  you may have to explicitly call apply() for the new element(s).


******************************************************************/

var AbsoluteFudge;  // setup as undefined

// create a suitable instance if IE5/6
/*@cc_on
@if (@_jscript)
@if (@_jscript_version > 5.6)

@else

  AbsoluteFudge = new Object();

  AbsoluteFudge.isAbsolute = function (element) {
    return (element.currentStyle.position == "absolute");
  }

  AbsoluteFudge.set = function(element) {
    if (element) {
      element.style.setExpression("height", "AbsoluteFudge.fudgeHeight(this)");
      element.style.setExpression("width", "AbsoluteFudge.fudgeWidth(this)");
    }
  }

  AbsoluteFudge.apply = function(element, recurse, full) {
    for (var i = 0; i < element.childNodes.length; i++) {
      var child = element.childNodes[i];
      if (child.nodeType == 1) {
        if (this.isAbsolute(child)) {
          this.set(child);
          if (recurse) {
            this.apply(child, recurse, full);
          }
        }
        else {
          if (full && recurse) {
            this.apply(child, recurse, full);
          }
        }
      }
    }
  }

  AbsoluteFudge.fudgeWidth = function(el) {
  if (el.currentStyle.right !!= "auto") {
    try {
      var parent = el;
      var w = 0;
      do {
        parent = parent.parentNode;
        w = parent.clientWidth;
      }
      while (w == 0);
      if (document.documentElement.clientHeight !!= 0) {
        // in standards mode so width that gets set is inside padding/margin
        w = w - parseInt(el.currentStyle.paddingLeft)
              - parseInt(el.currentStyle.paddingRight);

        if (el.currentStyle.borderLeftStyle !!= "none") {
          try {
            w = w - parseInt(el.currentStyle.borderLeftWidth);
          }
          catch(e) {
            w = w - 2; //estimated
          }
        }
        if (el.currentStyle.borderRightStyle !!= "none") {
          try {
            w = w - parseInt(el.currentStyle.borderRightWidth);
          }
          catch(e) {
            w = w -2; //estimated
          }
        }
      }
      el.style.width = (w - parseInt(el.currentStyle.left) - parseInt(el.currentStyle.right)) + "px";
    }
    catch(e) { }
  }
}

  AbsoluteFudge.fudgeHeight = function(el) {
  if (el.currentStyle.bottom !!= "auto") {
    try {
      var parent = el;
      var h = 0;
      do {
        parent = parent.parentNode;
        h = parent.clientHeight;
      }
      while (h == 0);
      if (document.documentElement.clientHeight !!= 0) {
        //standards mode
        h = h - parseInt(el.currentStyle.paddingTop)
              - parseInt(el.currentStyle.paddingBottom);
        if (el.currentStyle.borderTopStyle !!= "none") {
          try {
            h = h - parseInt(el.currentStyle.borderTopWidth);
          }
          catch(e) {
            h = h - 2;
          }
        }
        if (el.currentStyle.borderBottomStyle !!= "none") {
          try {
            h = h - parseInt(el.currentStyle.borderBottomWidth);
          }
          catch(e) {
            h = h - 2;
          }
        }
      }
      var x = (h - parseInt(el.currentStyle.top) - parseInt(el.currentStyle.bottom)) + "px";
      el.style.height = x;
    }
    catch(e) {}
  }
}


@end
@end
@*/

'! !

!WAAbsoluteFudgeJS methodsFor: 'as yet unclassified' stamp: 'kph 4/4/2008 00:50'!
selectorsToInclude

^ #( #absoluteFudgeJs )! !

!WAAbsoluteFudgeJS methodsFor: 'as yet unclassified' stamp: 'kph 4/5/2008 04:08'!
updateRoot: htmlRoot.

	htmlRoot context session addLoadScript: 'if (AbsoluteFudge !!= undefined) { AbsoluteFudge.apply(document.getElementsByTagName("body")[0], true, true)}'.! !

WAFileLibrary subclass: #WACss
	instanceVariableNames: 'css'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Seaside28Jetsam-Useful-CSS'!

WACss class
	instanceVariableNames: 'soleInstance'!

WACss class
	instanceVariableNames: 'soleInstance'!

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 21:44'!
all
 	^ self soleInstance css contents 
  ! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 11/20/2007 09:38'!
compilerClass

	self onClassChanged.
	
	^ super compilerClass! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 18:34'!
freeSomeSpace

	self resetCache! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 5/23/2008 10:40'!
generate 

	soleInstance := self basicNew initialize.
	
	((self allSelectorsBelow: WACss) 
		select: [ :sel | sel beginsWith: #css ]) asSortedCollection 
		do: [ :sel |  soleInstance perform: sel ].
		
	^ soleInstance! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 21:44'!
new
	^ self soleInstance  ! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 11/18/2007 02:43'!
onClassChanged
	"this little trick ensures that any changes to the css methods invalidate the cache"
	
	self withAllSubclassesDo: [ :each | each resetCache ].
	 
 ! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 11/11/2007 18:34'!
resetCache

	soleInstance := nil.! !

!WACss class methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 21:43'!
soleInstance
	^ soleInstance ifNil: [ soleInstance := self generate ].
	 ! !

!WACss methodsFor: 'as yet unclassified' stamp: 'kph 10/17/2007 02:49'!
css

	^ css ! !

!WACss methodsFor: 'as yet unclassified' stamp: 'kph 5/23/2008 13:08'!
css9000ClearFix


css << '
 
.clear:after {
    content: "."; 
    display: block; 
    height: 0; 
    clear: both; 
    visibility: hidden;
}

.clear {display: inline-block;
	clear: both;}

/* Hides from IE-mac \*/
* html .clear {height: 1%;}
.clear {display: block;}
/* End hide from IE-mac */
'! !

!WACss methodsFor: 'as yet unclassified' stamp: 'kph 5/23/2008 10:51'!
fileSelectors
 
	^  (((self class withAllSuperclasses upTo: WAFileLibrary) 
			gather:[:aClass | aClass selectors])
				select: [ :each | self isFileSelector: each ])  
										difference: self nonFileSelectors   ! !

!WACss methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 21:40'!
generatedCss

	^ self class all! !

!WACss methodsFor: 'as yet unclassified' stamp: 'kph 6/17/2008 16:12'!
initialize

	css := String new writeStream! !

!WACss methodsFor: 'as yet unclassified' stamp: 'kph 5/19/2008 21:38'!
selectorsToInclude

 ^ # ( generatedCss )! !

!WALibrary class methodsFor: '*seaside28jetsam-resolving' stamp: 'kph 7/19/2007 20:29'!
libraryAt: aLibraryName

	^ self libraryName = aLibraryName   
		ifTrue: [ self default ] 
		ifFalse: [ nil ]! !

!WALibrary class methodsFor: '*seaside28jetsam-resolving' stamp: 'kph 9/7/2007 15:25'!
libraryName

	^ self name asString! !

!WALibrary methodsFor: '*seaside28jetsam-libraries' stamp: 'kph 9/28/2007 06:34'!
baseUrl
	"Answers the base URL for the receiver library.
	NOTE: it answers a default unless there is a configured one."

	^  self baseUrlDefault! !

!WALibrary methodsFor: '*seaside28jetsam-libraries' stamp: 'kph 9/28/2007 03:19'!
baseUrlDefault

	^ WAFileHandler default baseUrl! !

!WALibrary methodsFor: '*seaside28jetsam-libraries' stamp: 'kph 9/28/2007 06:34'!
baseUrlPreference
	"Answers the base URL for the receiver library.
	NOTE: it answers a default unless there is a configured one."

	^  (WACurrentSession value application preferenceAt: #resourceBaseUrl)
 
		in: [ :url| url isEmptyOrNil 
			ifTrue: [self baseUrlDefault ]
			ifFalse:[WAUrl fromString: url]]  
		! !

!WALibrary methodsFor: '*seaside28jetsam-libraries-accessing' stamp: 'kph 7/12/2007 10:57'!
libraryName

	^ self class libraryName ! !

!WALibrary methodsFor: '*seaside28jetsam-libraries-processing-override' stamp: 'sas 8/23/2007 14:44'!
urlForFile: aFilename

	^ self urlForFile: aFilename using: self baseUrl! !

!WALibrary methodsFor: '*seaside28jetsam-libraries-accessing' stamp: 'kph 8/3/2007 08:52'!
urlForFile: aFilename using: baseUrl
	^ baseUrl 
		addToPath: self libraryName;
		addToPath: aFilename;
		yourself! !

!WALibrary methodsFor: '*seaside28jetsam-libraries-processing-override' stamp: 'kph 8/3/2007 08:53'!
urlOf: aSymbol

	"the filename form is cannonical"
	^ self urlForFile: (self asFilename: aSymbol) using: self baseUrl! !

!WALibrary methodsFor: '*seaside28jetsam-libraries-processing-override' stamp: 'kph 8/3/2007 08:52'!
urlOf: aSymbol using: baseUrl
	^ baseUrl
		addToPath: self libraryName;
		addToPath: (self asFilename: aSymbol);
		yourself! !

!WARenderLoopMain methodsFor: '*seaside28jetsam-helpers-override' stamp: 'kph 10/27/2007 19:27'!
createRoot

	^ WAHelper helpersFor: self application addTo:  self rootClass new. 
	 ! !

!WADocumentHandler methodsFor: '*seaside28jetsam-document-override' stamp: 'kph 7/19/2007 13:50'!
mimeDocument

	"seaside jetsam extension 07, 

	enables documentClasses to signal respond with doNotCache by implementing #notCached"


	^ (mimeDocument isNil
			or: [document respondsTo: #notCached])
		ifTrue: [mimeDocument := document asMIMEDocumentType: mimeType]
		ifFalse: [mimeDocument]! !

!WADocumentHandler methodsFor: '*seaside28jetsam-document-override' stamp: 'kph 7/19/2007 13:48'!
response

	"seaside jetsam extension 07, 

	enables documentClasses to signal respond with doNotCache by implementing #notCached"


	| response |
	response := WAResponse new.
	response contents: self mimeDocument contentStream text.
	response contentType: (mimeType ifNil: [self mimeDocument contentType]).
 
	(document respondsTo: #notCached) 
		ifTrue: [ response doNotCache ]
		ifFalse: [ response headerAt: 'Expires' put: 'Thu, 01 Jan 2095 12:00:00 GMT' ].

	fileName ifNotNil: [ response attachmentWithFileName: fileName ].
	^ response! !
WADebugging initialize!
JSPackageInfo initialize!
